/* CLASS ARKABALL */

#include <math.h>
#include "arkasprite.h"

class ArkaBall: public ArkaSprite {
 public:
  ArkaBall(VirtualScreenSDL *virscr, const char *filename);
  void SetSpeed(double sp) { speed = sp; }
  double GetSpeed() { return(speed); }
  void SetRho(double r) { rho = r; }
  double GetRho() { return(rho); }
  void GetNewPos(int *nx, int *ny);
 private:
  double speed;
  double rho;
};

ArkaBall::ArkaBall(VirtualScreenSDL *virscr, const char *filename) {
  this->virscr = virscr;
  sprbits = new VirtualScreenSDL(filename);
  width = sprbits->GetWidth();
  height = sprbits->GetHeight();
  sprback = new VirtualScreenSDL(width, height);
  drawn = 0;  
  speed = 1.0;
  rho = 0.0;
}

void ArkaBall::GetNewPos(int *nx, int *ny) {
  *nx = (int)(posx+cos(rho)*speed);
  *ny = (int)(posy+sin(rho)*speed);
}
