#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>

#include "../include/class_virscrsdl.h"

#include "arkaworld.h"

SDL_Surface *screen = NULL;
VirtualScreenSDL *virscreen = NULL;
ArkaWorld *aworld = NULL;

int arka_error(int errn, void *data) {
  fprintf(stderr, "Error %i\n", errn);
  return(errn);
}

int arka_exit() {
  if (virscreen) delete virscreen;
  if (aworld) delete aworld;
  if (screen) SDL_FreeSurface(screen);
  SDL_Quit();
  return(0);
}

int main() {
  SDL_Init(SDL_INIT_VIDEO);
  TTF_Init();
  screen = SDL_SetVideoMode(640,480, 32, SDL_HWSURFACE);
  virscreen = new VirtualScreenSDL(screen);
  aworld = new ArkaWorld(virscreen);

  SDL_ShowCursor(SDL_DISABLE);
  
  SDL_WM_SetCaption("Arkanoid", NULL);

  char playing = 1;
  int mousex, mousey;
  while (playing) {
    SDL_Event ev;
    if (SDL_PollEvent(&ev) != 0) {
      switch (ev.type) {
        case SDL_QUIT: playing = 0; break;
      }
      SDL_GetMouseState(&mousex, &mousey);
      aworld->SetPadPos(mousex);
      aworld->Draw();
      virscreen->Show();
    }
  }
  
  delete aworld;
  delete virscreen;
  return arka_exit();
}
