/* CLASS ARKASPRITE */

#ifndef ARKASPRITE_H
#define ARKASPRITE_H

class ArkaSprite {
 public:
  ArkaSprite() {};
  ArkaSprite(VirtualScreenSDL *virscr, const char *filename);
  ~ArkaSprite();
  int GetWidth() { return(width); }
  int GetHeight() { return(height); }
  void GetSize(int *x, int *y) { *x = width; *y = height; };
  void SetPos(int x, int y);
  int Draw();
 protected:
  int width, height;
  int posx, posy;
  int drawn, drawnx,drawny;
  VirtualScreenSDL *virscr, *sprbits, *sprback;
};

ArkaSprite::ArkaSprite(VirtualScreenSDL *virscr, const char *filename) {
  this->virscr = virscr;
  sprbits = new VirtualScreenSDL(filename);
  width = sprbits->GetWidth();
  height = sprbits->GetHeight();
  sprback = new VirtualScreenSDL(width, height);
  drawn = 0;
}

ArkaSprite::~ArkaSprite() {
  if (sprbits) delete sprbits;
  if (sprback) delete sprback;
}

void ArkaSprite::SetPos(int x, int y) {
  posx = x;
  posy = y;
}

int ArkaSprite::Draw() {
  if (drawn) sprback->CopyTo(drawnx, drawny, virscr);
  virscr->CopyRectTo(posx,posy, posx+width-1,posy+height-1, 0,0,sprback);
  sprbits->CopyTo(posx,posy, virscr);

  drawn = 1;
  drawnx = posx;
  drawny = posy;
}

#endif
