/* CLASS ARKAWORLD */

#define min(a,b)	(((a)<(b))?(a):(b))
#define max(a,b)	(((a)>(b))?(a):(b))

#include "arkapad.h"
#include "arkaball.h"

class ArkaWorld {
 public:
  ArkaWorld(VirtualScreenSDL *virscr);
  ~ArkaWorld();
  int SetPadPos(int mousex);
  int Draw();
  int DrawPad();
  int DrawBall();
  int MoveBall();
 private:
  int width, height;
  
  ArkaPad *pad;
  int padx,pady;
  
  ArkaBall *ball;
  int ballx,bally;
  
  VirtualScreenSDL *virscr;
};

ArkaWorld::ArkaWorld(VirtualScreenSDL *virscr) {
  this->virscr = virscr;
  width = 400;
  height = 300;
  pad = new ArkaPad(virscr, "img/pad.gif");
  padx = 0;
  pady = height-pad->GetHeight()-10;
  ball = new ArkaBall(virscr, "img/ball.gif");
  ballx = padx+pad->GetHeight()>>1;
  bally = pady-ball->GetHeight();
  ball->SetPos(ballx, bally);
  ball->SetRho(M_PI/6.0);
}

ArkaWorld::~ArkaWorld() {
  if (pad) delete pad;
  if (ball) delete ball;
}

int ArkaWorld::SetPadPos(int mousex) {
  padx = min(mousex, width-pad->GetWidth());
  pad->SetPos(padx, pady);
  return( padx );
}

int ArkaWorld::DrawPad() {
  pad->Draw();
}

int ArkaWorld::DrawBall() {
  ball->Draw();
}

int ArkaWorld::Draw() {
  MoveBall();
  DrawPad();
  DrawBall();
}

int ArkaWorld::MoveBall() {
  int nx,ny;
  ball->GetNewPos(&nx, &ny);
  ball->SetPos(nx, ny);
}
