#include "Corpo.h"

Corpo::Corpo(): 
  m(DEFAULT_MASSA), r(DEFAULT_RAGGIO), pos(Vector()), vel(Vector())
{
}

Corpo::Corpo(double mm): 
  m(mm), r(DEFAULT_RAGGIO), pos(Vector()), vel(Vector())
{
}

Corpo::Corpo(double mm, double ra): 
  m(mm), r(ra), pos(Vector()), vel(Vector())
{
}

Corpo::Corpo(double mm, double ra, const Vector &p):
  m(mm), r(ra), pos(p), vel(Vector())
{
}

Corpo::Corpo(double mm, double ra, const Vector &p, const Vector &v): 
  m(mm), r(ra), pos(p), vel(v)
{
}

bool Corpo::intersects(const Corpo &c) const {
  return (pos-c.pos).norm() <= (r+c.r);
}
