/* Classe che rappresenta un corpo circolare dotato di massa */

#ifndef CORPO_H
#define CORPO_H

#include "Vector.h"

#define DEFAULT_MASSA		10
#define DEFAULT_RAGGIO		10

class Corpo {
  
  public:
  
    // costruttori
    Corpo();
    Corpo(double m);
    Corpo(double m, double r);
    Corpo(double m, double r, const Vector &pos);
    Corpo(double m, double r, const Vector &pos, const Vector &vel);
    
    // legge proprietà
    inline double get_m() const { return m; }
    inline double get_r() const { return r; }
    inline Vector get_pos() const { return pos; }
    inline Vector get_vel() const { return vel; }
    
    // imposta proprietà
    inline void set_pos(const Vector &p) { pos = p; }
    inline void set_vel(const Vector &v) { vel = v; }
    
    // controlla se interseca un altro corpo
    bool intersects(const Corpo &c) const;
  
  protected:
    
    // massa
    double m;
    
    // raggio
    double r;
    
    // posizione
    Vector pos;
    
    // velocità
    Vector vel;
};

#endif