#include "Universo.h"

void Universo::set_limits(double mx, double my, double MX, double MY) {
  minx = mx;
  miny = my;
  maxx = MX;
  maxy = MY;
}

void Universo::animate() {
  move_stuff();
  check_collisions();
}

void Universo::move_stuff() {
  vector<Corpo>::iterator it = corpi.begin();
  for ( ; it < corpi.end(); it++ ) {
    Vector p = it->get_pos();
    it->set_pos(p+it->get_vel());
  }
}

void Universo::check_collisions() {
  
  vector<Corpo>::iterator it = corpi.begin();
  for ( ; it < corpi.end(); it++ ) {
    // collisioni con muri
    Vector p = it->get_pos();
    if (p.get_x()-it->get_r() <= minx || p.get_x()+it->get_r() >= maxx) 
      it->set_vel(Vector(-it->get_vel().get_x(),it->get_vel().get_y()));
    p = it->get_pos();
    if (p.get_y()-it->get_r() <= miny || p.get_y()+it->get_r() >= maxy)
      it->set_vel(Vector(it->get_vel().get_x(),-it->get_vel().get_y()));
    
    // collisioni con altri corpi
    vector<Corpo>::iterator it2 = it+1;
    for ( ; it2 < corpi.end(); it2++ ) {
      if (it->intersects(*it2)) {
	// COLLISIONE!!

	// velocità dei 2 corpi
	Vector v1 = it->get_vel();
	Vector v2 = it2->get_vel();
	// vettore che unisce i centri
	Vector dc = it2->get_pos()-it->get_pos();
	// proiezioni di v1 su dc 
	Vector v1paral = v1.project(dc);
	Vector v1perp = v1-v1paral;
	// proiezioni di v2 su dc
	Vector v2paral = v2.project(dc);
	Vector v2perp = v2-v2paral;
	
	// calcolo le nuove velocità
	if (it->get_m() == it2->get_m()) { // caso facile: masse uguali
	  v1 = v1perp+v2paral;
	  v2 = v2perp+v1paral; 
	} else { // caso rognoso: masse diverse
	  double M = it->get_m() + it2->get_m(); // somma delle masse
	  double DM = it->get_m() - it2->get_m(); // differenza delle masse
	  Vector v2mparal = v1paral*(DM/M) + v2paral*(2*it2->get_m()/M);
	  Vector v1mparal = v2paral*(-DM/M) + v1paral*(2*it->get_m()/M);
	  v1 = v1perp+v2mparal;
	  v2 = v2perp+v1mparal; 
	}
	it->set_vel(v1);
	it2->set_vel(v2);
      }
    }
  }
}
