#include <ctype.h>
#include <iostream>
#include <string>
#include <vector>
#include "cryptogram.h"

// TODO: validate list 0 ____ .... ___ 0

using std::string;
using std::vector;
using std::ostream;

// Constructor: standard
Cryptogram::Cryptogram() {
}

// Constructor: from a string like "1 2 3   5  3 2"
Cryptogram::Cryptogram(const string& s) {
  char buff[10] = "";
  char firstblank = 1, secondblank = 0;
  int blen = 0;

  for (int i=0; i<s.length(); i++) {
    char c = s[i];
    
    if (isdigit(c)) {
      if (blen >= 9) continue;
      buff[blen++] = c;
      buff[blen] = 0;
      firstblank = 1;
    } else {
      if (firstblank) {
        list.push_back(atoi(buff));
        buff[0] = 0;
        blen = 0;
        firstblank = 0;
        secondblank = 1;
      } else if (secondblank) {
        list.push_back(0);
        secondblank = 0;
      }
    }
  }
}


// ---- OPERATORS ------------------------------------------------------------

// []
int Cryptogram::operator [] (int i) const {
  if (i >= list.size()) return 0;
  return list[i];
}

// <<
ostream& operator << (ostream& os, const Cryptogram& c) {
  for (int i=0; i<c.list.size(); i++) 
    if (c.list[i]) os << c.list[i] << " ";
    else os << "  ";
  os << std::endl;
  return os;
}


// ---- PUBLIC METHODS -------------------------------------------------------

// Returns the length of the cryptogram
int Cryptogram::length() const {
  return list.size();
}

// Encode a plain text into a cryptogram
void Cryptogram::load_text(const string& s) {
  char fl;
  int sym_counter = 1, sym_table[26];
  memset(sym_table, 0xff, 26*sizeof(int));
  
  list.clear();
  
  for (int i=0; i<s.length(); i++) {
    char c = tolower(s[i]);
    if (c >= 'a' && c <= 'z') {
      if (sym_table[c-'a'] == -1) sym_table[c-'a'] = sym_counter++;
      list.push_back(sym_table[c-'a']);
      fl = 1;
    } else {
      if (c == ' ' && fl) {
        list.push_back(0); 
        fl = 0;
      }
    }
  }
}

// Returns a vector with every word in the cryptogram
vector<Cryptogram> Cryptogram::extract_words() const {
  vector<Cryptogram> ret;
  vector<int>::const_iterator i1, i2;
  Cryptogram tc;
  i1 = list.begin();
  i2 = list.begin();

  while (i2 != list.end()) {
    if (*i2 == 0) {
      tc.list = vector<int> (i1, i2);
      ret.push_back(tc);
      i1 = i2;
      i1++;
    }
    i2++;
  }
  if (i1 < i2) {
    tc.list = vector<int> (i1, i2);
    ret.push_back(tc);
  }
  
  return ret;
}
