#ifndef _DICT_H
#define _DICT_H

#include <string>
#include <fstream>
#include <iostream>
#include <sys/types.h>
#include <regex.h>

/*
  TODO:
  operator >>
  finish smart handling of shortest/longest
*/

class Dict {
 public:
  Dict();
  Dict(const Dict& d);
  Dict(const std::string& filename);
  ~Dict();
  
  friend std::ostream& operator << (std::ostream& os, const Dict& d);
  //TODO: friend std::istream& operator >> (std::istream& is, const Dict& d);
  friend Dict operator + (const Dict& d1, const Dict& d2);
  friend Dict operator - (const Dict& d1, const Dict& d2);
  friend bool operator == (const Dict& d1, const Dict& d2);
  friend bool operator != (const Dict& d1, const Dict& d2);
  std::string operator [] (int i) const;
  Dict& operator = (const Dict& d);
  
  int length() const;
  int find(const std::string& s) const;
  bool is_present(const std::string& s) const;
  std::string get_longest();
  std::string get_shortest();
  void insert(const std::string& s);
  void remove(const std::string& s);
  void remove_all();
  void merge(const Dict& d);
  void subtract(const Dict& d);
  void intersect(const Dict& d);
  
  Dict regex_match(const std::string& re, int flags = REG_ICASE) const;
 private:
  int words;
  int longest_word, shortest_word;
  std::string **table;
  
  void calc_longest();
  void insert_tail(const std::string& s);
  static int cmp_stringp(const void *s1, const void *s2);
};

#endif
