#include "substtab.h"
#include <iostream>
#include <vector>

using std::ostream;
using std::vector;

// ---- CLASS SUBST ----------------------------------------------------------
Subst::Subst():
  value(1), sub('a'), power(1.0) {
}

Subst::Subst(int v, char s, double p):
  value(v), sub(s), power(p) {
}

// ---- OPERATORS ------------------------------------------------------------

bool operator == (const Subst& s1, const Subst& s2) {
  return (s1.value == s2.value) && (s1.sub == s2.sub) && (s1.power == s2.power);
}

bool operator != (const Subst& s1, const Subst& s2) {
  return !(s1 == s2);
}

// nonsense if s1 is not similar to s2
bool operator >  (const Subst& s1, const Subst& s2) { return s1.power >  s2.power; }
bool operator >= (const Subst& s1, const Subst& s2) { return s1.power >= s2.power; }
bool operator <  (const Subst& s1, const Subst& s2) { return s1.power <  s2.power; }
bool operator <= (const Subst& s1, const Subst& s2) { return s1.power <= s2.power; }

bool operator >  (const Subst& s1, double d) { return s1.power >  d; }
bool operator >= (const Subst& s1, double d) { return s1.power >= d; }
bool operator <  (const Subst& s1, double d) { return s1.power <  d; }
bool operator <= (const Subst& s1, double d) { return s1.power <= d; }


ostream& operator << (ostream& os, const Subst& s) {
  return os << s.value << " => " << s.sub << " (" << s.power << ")";
}

// ---- PUBLIC METHODS -------------------------------------------------------
bool Subst::is_similar(const Subst& s) const {
  return (value == s.value) && (sub == s.sub);
}



// ---- CLASS SUBSTTAB -------------------------------------------------------


SubstTab::SubstTab() {
}

// ---- OPERATORS ------------------------------------------------------------

ostream& operator << (ostream& os, const SubstTab& s) {
  for (int i=0; i<27; i++) {
    os << i << " => ";
    for (int j=0; j<s.list[i].size(); j++)
      os << "'" << s.list[i][j].sub << "' (" << s.list[i][j].power << "), ";
    os << "\n";
  }
  return os;
}

// ---- PUBLIC METHODS -------------------------------------------------------

// Inserts a subst
void SubstTab::insert(const Subst& s) {
  int pos = s.value;
  if (s.value < 0 || s.value > 26) return;
  vector<Subst>::iterator j,i = list[s.value].begin();
  for (j=i; i<list[s.value].end(); i++) {
    if (list[s.value][i].sub == s.sub) return;
    
    // TODO
    if (j == i && list[s.value][i].power s.power)
  }
}
