#ifndef _SUBSTTAB_H
#define _SUBSTTAB_H

#include <vector>
#include <iostream>

class SubstTab;

class Subst {
 public:
  Subst();
  Subst(int, char, double = 1.0);
  
  friend class SubstTab;
  
  friend bool operator == (const Subst& s1, const Subst& s2);
  friend bool operator != (const Subst& s1, const Subst& s2);
  friend bool operator >  (const Subst& s1, const Subst& s2);
  friend bool operator >= (const Subst& s1, const Subst& s2);
  friend bool operator <  (const Subst& s1, const Subst& s2);
  friend bool operator <= (const Subst& s1, const Subst& s2);

  friend bool operator >  (const Subst& s1, double d);
  friend bool operator >= (const Subst& s1, double d);
  friend bool operator <  (const Subst& s1, double d);
  friend bool operator <= (const Subst& s1, double d);

  friend std::ostream& operator << (std::ostream& os, const Subst& s);
  friend std::ostream& operator << (std::ostream& os, const SubstTab& s);
  
  bool is_similar(const Subst& s) const;
 private:
  int value;
  char sub;
  double power;
};


// ---- CLASS SUBSTTAB -------------------------------------------------------

class SubstTab {
 public:
  SubstTab();
  
  friend std::ostream& operator << (std::ostream& os, const SubstTab& s);
  
  void insert(const Subst& s);
 private:
  std::vector<Subst> list[27];
};

#endif
