#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <SDL/SDL.h>

#include "../include/class_virscrsdl.h"

#define DEMO_DELAY	40

int sizex = 512, sizey = 384;
char fEnableFullscreen = 0;
SDL_Surface *screen;
VirtualScreenSDL *virscr;

inline int rgb2int(Uint8 r,Uint8 g,Uint8 b) {
  return SDL_MapRGB(screen->format, r, g, b);
}

#include "demo1.h"
#include "demo2.h"

void do_demo() {
  static Uint32 time0 = SDL_GetTicks();
  Uint32 time = SDL_GetTicks()-time0;
  
  //time += 14000;

  if (time < 5000) {
    virscr->Clear(0);
    static int txtcol = 0xff000000;
    virscr->TextAlign = VS_TA_CENTER;
    virscr->TextMode = VS_TM_BLENDED;
    if (time < 2000)
      txtcol = rgb2int(time/10,time/20,0) | 0xff000000;
    else if (time < 4000)
      txtcol = 0xffc86400;
    else 
      txtcol = rgb2int(200-(time-4000)/5,100-(time-4000)/10,0) | 0xff000000;
    virscr->PrintRect(0, 0,(sizey-18)>>1,sizex,sizey, "are you ready?", txtcol,0);
  } else if (time < 15000) {
    demo1(time-5000, 15000);
  } else if (time < 25000) {
    demo2(time-15000, 25000);
  } else {
    virscr->Clear(0);
  }

  virscr->Show();
}

void do_precalc() {
  pre_demo1();
  pre_demo2();
}

void do_endcalc() {
  end_demo2();
  end_demo1();
}

Uint32 timeleft() {
  static Uint32 nexttime = 0;
  Uint32 now = SDL_GetTicks();
  
  if (nexttime <= now) {
    /* not very good */
    if (nexttime < now-DEMO_DELAY) fprintf(stderr, "Frame skipped\n");
    nexttime = now+DEMO_DELAY;
    return(0);
  }
  return(nexttime-now);
}

/* not done yet */
void parse_cmd(int argc, char *argv[]) {
  for (int i=1; i<argc; i++) {
    if (strcmp(argv[i], "--fullscreen") == 0) {
      fEnableFullscreen = 1;
    }
  }
}

int main(int argc, char *argv[]) {
  SDL_Event ev;
  int playing = 1;
  int pause = 0;
  
  parse_cmd(argc, argv);
  
  SDL_Init(SDL_INIT_VIDEO);
  TTF_Init();
  
  screen = SDL_SetVideoMode(sizex, sizey, 32, SDL_HWSURFACE | (fEnableFullscreen?SDL_FULLSCREEN:0) | SDL_SRCALPHA);
  SDL_SetAlpha(screen, SDL_SRCALPHA, 0xff);
  virscr = new VirtualScreenSDL(screen);
  
  SDL_ShowCursor(SDL_DISABLE);
  SDL_EventState(SDL_MOUSEMOTION, SDL_IGNORE);
  SDL_EventState(SDL_MOUSEBUTTONUP, SDL_IGNORE);
  SDL_EventState(SDL_MOUSEBUTTONDOWN, SDL_IGNORE);
  SDL_EventState(SDL_ACTIVEEVENT, SDL_IGNORE);
  
  virscr->LoadFont("fabian.ttf", 18); // used for various messages
  virscr->LoadFont("battlefield.ttf", 20);
  
  virscr->Print(0, 10,10, "Loading...", 0xffff7f00,0);
  virscr->Show(0,0, sizex,30);
  do_precalc();
  
  while (playing) {
    if (SDL_PollEvent(&ev)) {
      switch (ev.type) {
        case SDL_QUIT: 
          playing=0; 
          break;
        case SDL_KEYDOWN: 
          if (ev.key.keysym.sym == SDLK_ESCAPE) playing = 0; 
          if (ev.key.keysym.sym == SDLK_p) pause ^= 1;
          break;
      }
    }
    if (!pause) {
      do_demo();
    }
    SDL_Delay(timeleft());
  }
  
  do_endcalc();
  delete virscr;
  SDL_Quit();
  return(0);
}
