#ifndef CELL_H
#define CELL_H

#include "defs.h"

class Cell {
 public:
  Cell();
  Cell(char x, char y, int value);
  Cell(const Cell& c);
  
  Cell& operator =(const Cell& c);
  
  inline char x() const { return cx; }
  inline char y() const { return cy; }
  inline void xy(char *rx, char *ry) const { *rx = cx; *ry = cy; }
  
  inline int value() const { return cvalue; }
  bool has(int items) const;
  
  inline void mark() { cvalue |= MAP_MARK; }
  inline void unmark() { cvalue &= ~MAP_MARK; }
  
  inline bool marked() const { return has(MAP_MARK); }
  inline bool invalid() const { return (cvalue & MAP_INVALID); }
  
 private:
  char cx, cy;
  int cvalue;
  
};

int cell_dist1(const Cell& c1, const Cell& c2);
int cell_dist2(const Cell& c1, const Cell& c2);

#endif
