#ifndef LABYRINTH_H
#define LABYRINTH_H

#include "path.h"
#include "cell.h"

class Labyrinth {
 public:
  Labyrinth(const char *filename);
  Labyrinth(const Labyrinth&);
  ~Labyrinth();
  
  int read_from_file(const char *filename);
  //int save_to_file(const char *filename);
  //int print(const Path *p = NULL) const;
  
  Cell get(int x, int y) const;
  
  inline int get_size_x() const { return sizex; }
  inline int get_size_y() const { return sizey; }

  inline int get_start_x() const { return startx; }
  inline int get_start_y() const { return starty; }
  
  inline int get_end_x() const { return endx; }
  inline int get_end_y() const { return endy; }
  
  void mark(int x, int y);
  void unmark(int x, int y);
  
 private:
  Cell* map;
  Path *teleports;
  
  int sizex, sizey;
  int startx, starty;
  int endx, endy;
  
  inline void set(int x, int y, const Cell &value);
  
};


#endif
