#ifndef PATH_H
#define PATH_H

#include <stdlib.h>
#include "cell.h"

/* todo:
  costruttore con parametro Labyrinth
*/


class Path {
 // a path in the Labyrinth
 public:
  Path();
  Path(const Path& p);
  ~Path();
  
  Path& operator =(const Path& p);
  
  inline int get_score() const { return score; };
  inline int set_score(int s) { score = s; };
  inline int get_lives() const { return lives; };
  inline int set_lives(int l) { lives = l; };

  inline int length() const { return len; };
  
  Cell get(int i) const;
  void add_tail(const Cell& c);
  void del_tail();
  
  void clear();
  
  int value() const;
  
  bool is_in(const Cell& c, Cell *prev = NULL, Cell *next = NULL) const;
  
 private:
  int score, lives;
  int cells_alloc;
  int len; //, *cells;
  Cell *cells;
};


#endif
