#ifndef PLAYER_H
#define PLAYER_H

#include "labyrinth.h"
#include "labydisplay.h"
#include "path.h"

#define PLAYER_INIT_SCORE	0
#define PLAYER_INIT_LIVES	5

#define PLAYER_MOVE_UP		1
#define PLAYER_MOVE_DOWN	2
#define PLAYER_MOVE_LEFT	3
#define PLAYER_MOVE_RIGHT	4


class Player {
 public:
  Player(Labyrinth *l);
  ~Player();
  
  inline int get_score() const { return score; }
  inline int get_lives() const { return lives; }
  
  bool at_begin() const;
  bool at_end() const;
  inline bool is_died() const { return lives <= 0; }
  
  inline bool can_go_up() const { return can_go(PLAYER_MOVE_UP); }
  inline bool can_go_down() const { return can_go(PLAYER_MOVE_DOWN); }
  inline bool can_go_left() const { return can_go(PLAYER_MOVE_LEFT); }
  inline bool can_go_right() const { return can_go(PLAYER_MOVE_RIGHT); }
  
  void walk();
  
 private:
  Labyrinth *laby;
  LabyDisplay *ld;
  
  int posx, posy;
  int score, lives, keys, shield;
  Path *path, *lastpath;
  
  bool can_go(int dir) const;
};



#endif
