BITS 32

section .text

global isMMX
global isMMX2

; result (if exist) is in EDX:EAX
global _mm_empty
global _mm_packs_pi16
global _mm_packs_pi32
global _mm_packs_pu16
global _mm_add_pi8
global _mm_add_pi16
global _mm_add_pi32
global _mm_adds_pi8
global _mm_adds_pi16
global _mm_adds_pu8
global _mm_adds_pu16
global _mm_and_si64
global _mm_andnot_si64
global _mm_avg_pu8
global _mm_avg_pu16
global _mm_cmpeq_pi8
global _mm_cmpeq_pi16
global _mm_cmpeq_pi32
global _mm_cmpgt_pi8
global _mm_cmpgt_pi16
global _mm_cmpgt_pi32
global _mm_extract_pi16
global _mm_insert_pi16
global _mm_madd_pi16
global _mm_max_pi16
global _mm_max_pu8
global _mm_min_pi16
global _mm_min_pu8
global _mm_movemask_pi8
global _mm_mulhi_pu16
global _mm_mulhi_pi16
global _mm_mullo_pi16
global _mm_or_si64
global _mm_sad_pu8
global _mm_sll_pi16
; global _mm_slli_pi16
global _mm_sll_pi32
; global _mm_slli_pi32
global _mm_sll_si64
; global _mm_slli_si64
global _mm_sra_pi16
; global _mm_srai_pi16
global _mm_sra_pi32
; global _mm_srai_pi32
global _mm_srl_pi16
; global _mm_srli_pi16
global _mm_srl_pi32
; global _mm_srli_pi32
global _mm_srl_si64
; global _mm_srli_si64
global _mm_sub_pi8
global _mm_sub_pi16
global _mm_sub_pi32
global _mm_subs_pi8
global _mm_subs_pi16
global _mm_sub_pu8
global _mm_sub_pu16
global _mm_unpckhi_pi8
global _mm_unpckhi_pi16
global _mm_unpckhi_pi32
global _mm_unpcklo_pi8
global _mm_unpcklo_pi16
global _mm_unpcklo_pi32
global _mm_xor_si64

NULL   EQU  0
TRUE   EQU  001h
FALSE  EQU  000h

isMMX:
  pushad
  pushfd
  pop	eax
  or	eax, 00200000h	; set bit 21 of EFLAGS
  push	eax
  popfd
  pushfd
  pop	eax
  test	eax, 00200000h
  jz	.notMMX		; cpuid not supported
  mov	eax, 001h
  cpuid
  test	edx, 00800000h
  jz	.notMMX
  popad
  mov	eax, TRUE
  ret
 .notMMX:
  popad
  mov	eax, FALSE
  ret

isMMX2:
  pushad
  pushfd
  pop	eax
  or	eax, 00200000h	; set bit 21 of EFLAGS
  push	eax
  popfd
  pushfd
  pop	eax
  test	eax, 00200000h
  jz	.notMMX2 	; cpuid not supported
  mov	eax, 001h
  cpuid
  test	edx, 00800000h
  jz	.notMMX2
  mov	eax, 80000001h
  cpuid
  test	edx, 00400000h
  jz	.notMMX2
  popad
  mov	eax, TRUE
  ret
 .notMMX2:
  popad
  mov	eax, FALSE
  ret


_mm_empty:
  emms
  ret

_mm_packs_pi16:
  movq	mm0, [esp+4]
  packsswb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_packs_pi32:
  movq	mm0, [esp+4]
  packssdw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_packs_pu16:
  movq	mm0, [esp+4]
  packuswb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_add_pi8:
  movq	mm0, [esp+4]
  paddb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_add_pi16:
  movq	mm0, [esp+4]
  paddw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_add_pi32:
  movq	mm0, [esp+4]
  paddd mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_adds_pi8:
  movq	mm0, [esp+4]
  paddsb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_adds_pi16:
  movq	mm0, [esp+4]
  paddsw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_adds_pu8:
  movq	mm0, [esp+4]
  paddusb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_adds_pu16:
  movq	mm0, [esp+4]
  paddusw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_and_si64:
  movq	mm0, [esp+4]
  pand	mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_andnot_si64:
  movq	mm0, [esp+4]
  pandn mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_avg_pu8:
  movq	mm0, [esp+4]
  pavgb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_avg_pu16:
  movq	mm0, [esp+4]
  pavgw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_cmpeq_pi8:
  movq	mm0, [esp+4]
  pcmpeqb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_cmpeq_pi16:
  movq	mm0, [esp+4]
  pcmpeqw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_cmpeq_pi32:
  movq	mm0, [esp+4]
  pcmpeqd mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_cmpgt_pi8:
  movq	mm0, [esp+4]
  pcmpgtb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_cmpgt_pi16:
  movq	mm0, [esp+4]
  pcmpgtw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_cmpgt_pi32:
  movq	mm0, [esp+4]
  pcmpgtd mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_extract_pi16:
  movq	mm0, [esp+4]
  mov	al, [esp+12]
  and	al, 003h
  cmp	al, 001h
  je	_mm_extract_pi16_1
  ja	_mm_extract_pi16_a1
  pextrw eax, mm0, 0
  ret
 _mm_extract_pi16_1:
  pextrw eax, mm0, 1
  ret
 _mm_extract_pi16_a1:
  cmp	al, 003h
  je	_mm_extract_pi16_3
 _mm_extract_pi16_2:
  pextrw eax, mm0, 2
  ret
 _mm_extract_pi16_3:
  pextrw eax, mm0, 3
  ret

_mm_insert_pi16:
  movq	mm0, [esp+4]
  mov	al, [esp+16]
  and	al, 003h
  cmp	al, 001h
  je	.mm_insert_pi16_1
  ja	.mm_insert_pi16_a1
  pinsrw mm0, [esp+12], 0
  jmp   .mm_insert_pi16_end
 .mm_insert_pi16_1:
  pinsrw mm0, [esp+12], 1
  jmp   .mm_insert_pi16_end
 .mm_insert_pi16_a1:
  cmp	al, 003h
  je	.mm_insert_pi16_3
 .mm_insert_pi16_2:
  pinsrw mm0, [esp+12], 2
  jmp   .mm_insert_pi16_end
 .mm_insert_pi16_3:
  pinsrw mm0, [esp+12], 3
 .mm_insert_pi16_end:
  jmp   _mm_common_epilogue

_mm_madd_pi16:
  movq  mm0, [esp+4]
  pmaddwd mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_max_pi16:
  movq  mm0, [esp+4]
  pmaxsw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_max_pu8:
  movq  mm0, [esp+4]
  pmaxub mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_min_pi16:
  movq  mm0, [esp+4]
  pminsw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_min_pu8:
  movq  mm0, [esp+4]
  pminub mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_movemask_pi8:
  movq  mm0, [esp+4]
  pmovmskb eax, mm0
  ret

_mm_mulhi_pu16:
  movq	mm0, [esp+4]
  pmulhuw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_mulhi_pi16:
  movq	mm0, [esp+4]
  pmulhw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_mullo_pi16:
  movq	mm0, [esp+4]
  pmullw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_or_si64:
  movq	mm0, [esp+4]
  por	mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sad_pu8:
  movq	mm0, [esp+4]
  psadbw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sll_pi16:
  movq	mm0, [esp+4]
  psllw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sll_pi32:
  movq	mm0, [esp+4]
  pslld mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sll_si64:
  movq	mm0, [esp+4]
  psllq mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sra_pi16:
  movq	mm0, [esp+4]
  psraw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sra_pi32:
  movq	mm0, [esp+4]
  psrad mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_srl_pi16:
  movq	mm0, [esp+4]
  psrlw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_srl_pi32:
  movq	mm0, [esp+4]
  psrld mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_srl_si64:
  movq	mm0, [esp+4]
  psrlq mm0, [esp+12]
  jmp   _mm_common_epilogue
  
_mm_sub_pi8:
  movq	mm0, [esp+4]
  psubb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sub_pi16:
  movq	mm0, [esp+4]
  psubw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sub_pi32:
  movq	mm0, [esp+4]
  psubd mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_subs_pi8:
  movq	mm0, [esp+4]
  psubsb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_subs_pi16:
  movq	mm0, [esp+4]
  psubsw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sub_pu8:
  movq	mm0, [esp+4]
  psubusb mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_sub_pu16:
  movq	mm0, [esp+4]
  psubusw mm0, [esp+12]
  jmp   _mm_common_epilogue
  
_mm_unpckhi_pi8:
  movq	mm0, [esp+4]
  punpckhbw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_unpckhi_pi16:
  movq	mm0, [esp+4]
  punpckhwd mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_unpckhi_pi32:
  movq	mm0, [esp+4]
  punpckhdq mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_unpcklo_pi8:
  movq	mm0, [esp+4]
  punpcklbw mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_unpcklo_pi16:
  movq	mm0, [esp+4]
  punpcklwd mm0, [esp+12]
  jmp   _mm_common_epilogue

_mm_unpcklo_pi32:
  movq	mm0, [esp+4]
  punpckldq mm0, [esp+12]
  jmp   _mm_common_epilogue
  
_mm_xor_si64:
  movq	mm0, [esp+4]
  pxor  mm0, [esp+12]
  jmp   _mm_common_epilogue
  

; puts mm0 into edx:eax and returns
_mm_common_epilogue:
  sub   esp, 8
  movq	[esp], mm0
  pop	eax
  pop	edx
  ret
