/* ERRORS.H */
/* File header per errors.cpp */

#ifndef _ERRORS_H
#define _ERRORS_H

#define ERR_NOERROR		0
#define ERR_BADOPT		1
#define ERR_NOACTION		2
#define ERR_NOARCHIVE  		3
#define ERR_NOFILES		4
#define ERR_ARCCREAT		5
#define ERR_FILECLOSE		6
#define ERR_WRITE		7
#define ERR_OPENFILE		8
#define ERR_NOMATCH		9
#define ERR_NOCUBEMEM		10
#define ERR_NOFILESADDED	11
#define ERR_BADARCHIVE		12
#define ERR_PWDNOMATCH		13
#define ERR_NOMD5		14
#define ERR_BADMD5		15

#define ERRORS_COUNT		16

#define WARN_NOWARN		0
#define WARN_PWDCUT		1
#define WARN_PWDWEAK		2
#define WARN_NOSTAT		3
#define WARN_FILEEXISTS		4
#define WARN_BADVERSION		5
#define WARN_ARCCORRUPT		6
#define WARN_MANYOUTDIR		7
#define WARN_NOWRITESTAT	8

#define WARNINGS_COUNT		9

#define ASK_OVERWRITE		0

#define ASKS_COUNT		1

extern const char *txt_errors[ERRORS_COUNT];
extern const char *txt_warnings[WARNINGS_COUNT];
extern const char *txt_asks[ASKS_COUNT];

int error(int number, void *data);
int warn(int number, void *data);
int ask(int number, void *data);

#endif
