/* ARGS.H */
/* Manages arguments processing */

#include <argp.h>

/* Defines data for parameters */
const char *argp_program_version = "Laby "VERSION;
const char *argp_program_bug_address = AUTHOR" "AUTHOR_EMAIL;
const char *doc = "Laby e' un gioco labirintico!\n";
const char *args_doc = "";

/* Defines arguments */
static struct argp_option options[] = {
  {"level", 'l', "n", 0, "Inizia dal livello n"},
  {0}
};

struct s_arguments {
  int startlevel;
} arguments;

/* Parse arguments */
static error_t parse_opt(int key, char *arg, struct argp_state *state) {
  struct s_arguments *arguments = (s_arguments *)state->input;

  switch (key) {
    case 'l': arguments->startlevel = atoi(arg); break;
    default: return ARGP_ERR_UNKNOWN;
  }
  return 0;
}

static struct argp argp = { options, parse_opt, args_doc, doc };

int parse_args(int argc, char *argv[]) {
  /* Init default values */
  arguments.startlevel = 1;
  /* Do parsing */
  argp_parse(&argp, argc, argv, 0, NULL, &arguments);
  return 0;
}
