/* EDITLEV_ARGS.H */
/* Manages arguments processing */

#include <argp.h>

/* Defines data for parameters */
const char *argp_program_version = "Laby Level Editor "VERSION;
const char *argp_program_bug_address = AUTHOR" "AUTHOR_EMAIL;
const char *doc = "Editor di livelli per Laby\n";
const char *args_doc = "";

/* Defines arguments */
static struct argp_option options[] = {
  {"file", 'f', "name", 0, "Carica il livello name"},
  {"width", 'w', "x", 0, "Imposta la larghezza a x (solo nuovi livelli)"},
  {"height", 'h', "y", 0, "Imposta l'altezza a y (solo nuovi livelli)"},
  {0}
};

struct s_arguments {
  char *filename;
  short width, height;
} arguments;

/* Parse arguments */
static error_t parse_opt(int key, char *arg, struct argp_state *state) {
  struct s_arguments *arguments = (s_arguments *)state->input;

  switch (key) {
    case 'f': arguments->filename = arg; break;
    case 'w': arguments->width = atoi(arg); break;
    case 'h': arguments->height = atoi(arg); break;
    default: return ARGP_ERR_UNKNOWN;
  }
  return 0;
}

static struct argp argp = { options, parse_opt, args_doc, doc };

int parse_args(int argc, char *argv[]) {
  /* Init default values */
  arguments.filename = NULL;
  arguments.width = 40;
  arguments.height = 30;
  /* Do parsing */
  argp_parse(&argp, argc, argv, 0, NULL, &arguments);
  return 0;
}
