#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#define MASTER_LEN	4
#define MASTER_CHARS	9

const char chars[MASTER_CHARS+1] = {' ','1','2','3','4','5','6','7','8','9'};
const int totgames = 10;

char board[MASTER_LEN];

void displayBoard() {
  int i;
  printf("+");
  for (i=0; i<MASTER_LEN; i++) printf("---+");
  printf("\n|");
  for (i=0; i<MASTER_LEN; i++) printf(" %c |", chars[board[i]]);
  printf("\n+");
  for (i=0; i<MASTER_LEN; i++) printf("---+");
  printf("\n");
}

int evaluate(char *userboard) {
  int i,j, countok = 0, countmove=0;
  char workboard[MASTER_LEN];
  
  memcpy(workboard, board, sizeof(board));
  
  printf("User choice:");
  for (i=0; i<MASTER_LEN; i++) printf("%3c", chars[userboard[i]]);
  printf("  Result: ");
  
  for (i=0; i<MASTER_LEN; i++) {
    if (userboard[i] == workboard[i]) {
      countok++;
      userboard[i] = workboard[i] = 0;
    }
  }

  for (i=0; i<MASTER_LEN; i++) {
    if (userboard[i] == 0) continue;
    char v = userboard[i];
    for (j=0; j<MASTER_LEN; j++) {
      if (workboard[j] == v) {
        countmove++;
        userboard[i] = workboard[j] = 0;
        break;
      }
    }
  }
  
  for (i=0; i<countok; i++) printf(" X");
  for (i=0; i<countmove; i++) printf(" O");
  for (i=0; i<MASTER_LEN-(countok+countmove); i++) printf(" -");
  printf("\n");
  if (countok == MASTER_LEN) return(1); // won!
  return(0);
}

void play() {
  char playing =  1;
  char buff[50];
  int i, game=0;
  char usernum[MASTER_LEN+1];
  
  printf("Play!! (q to exit)\n");
  
  while (playing) {
    printf("write: ");
    fgets(buff, 50, stdin);
    buff[49] = '\0';
    if (buff[strlen(buff)-1] == '\n') buff[strlen(buff)-1] = '\0';
    if (buff[0] == 'q' || buff[0] == 'Q') 
      playing = 0;
    else {
      char *tok = strtok(buff, " \t");
      char tostop = 0;
      for (i=0; tok!=NULL; i++) {
        if (i > MASTER_LEN) break;
        usernum[i] = atoi(tok);
        if (usernum[i] <= 0 || usernum[i] > MASTER_CHARS) {
          printf("Not a valid number: %i\n", usernum[i]);
          tostop = 1;
          break;
        }
        tok = strtok(NULL, " \t");
      }
      if (tostop) continue;
      if (i != MASTER_LEN) {
        printf("Wrong amount of numbers.\n");
        continue;
      }
      if (evaluate(usernum)) {
        printf("You are great!\n");
        displayBoard();
        playing = 0;
      } else game++;
      if (game >= totgames) {
        printf("You suck!!\n");
        displayBoard();
        playing = 0;
      }
    }
  }
}

void initBoard() {
  srand(time(NULL));
  
  for (int i=0; i<MASTER_LEN; i++) {
    int c = rand()%MASTER_CHARS + 1;
    board[i] = c;
  }
}

int main() {
  
  initBoard();
  play();
  
  return(0);
}
