#include "person.h"
#include <iostream>
#include <string>

using std::string;
using std::ostream;

Person::Person(string nome) {
  this->nome.assign(nome);
  this->nascita = this->morte = 0;
}

Person::Person(string nome, int nascita, int morte) {
  this->nome.assign(nome);
  this->nascita = nascita;
  this->morte = (morte>=nascita)?morte:nascita;
}

string Person::get_nome() const {
  return nome;
}

int Person::get_nascita() const {
  return nascita;
}

int Person::get_morte() const {
  return morte;
}

ostream& operator<<(ostream &os, const Person& p) {
  return os << p.get_nome() << " (" << p.get_nascita() << " - " << p.get_morte() << ")";
}
