#include "monomio.h"
#include <iostream>

int Monomio::ipow(int x, int e) {
  if (e < 0) return 0;
  if (e == 0) return 1;
  return ipow(x, e-1)*x;
}

Monomio::Monomio() {
  this->coeff = 0;
  this->esp = 1;
}

Monomio::Monomio(int coeff, int esp = 1) {
  this->coeff = coeff;
  this->esp = (coeff==0)?1:esp;
}

bool Monomio::is_similar(const Monomio& m) {
  return (esp == m.esp);
}

int Monomio::operator () (int x) const {
  return coeff*ipow(x, esp);
}

bool operator == (const Monomio& m, int x) {
  if (m.coeff == 0 || m.esp == 0) return (x == m.coeff);
  return false;
}

Monomio Monomio::operator - () {
  Monomio m(-coeff, esp);
  return m;
}

ostream& operator << (ostream& os, const Monomio& m) {
  if (m.coeff != 1 || m.esp == 0) os << m.coeff;
  if (m.esp == 0 || m.coeff == 0) return os;
  os << "x";
  if (m.esp != 1) os << "^" << m.esp;
  return os;
}
