/* Esame 11/12/2006 - esercizio 1 */

#include <string>
#include <iostream>

class Abbonato {
 public:
  Abbonato(const std::string& name = "",const std::string& surname = ""): 
   nome(name), cognome(surname) {
  }
  virtual ~Abbonato() {};
  
  virtual double costoAttuale() const = 0;
  virtual std::string get_nome() const { return nome; };
  virtual std::string get_cognome() const { return cognome; };
 protected:
  std::string nome, cognome;
 private:
};

class AbbonatoTempo: public Abbonato {
 public:
  AbbonatoTempo(const std::string& name = "",const std::string& surname = ""): 
   Abbonato(name, surname), sec(1230) {
  }
  virtual double costoAttuale() const {
    return sec*0.002;
  }
 protected:
  long sec;
 private:
};

class AbbonatoTraffico: public Abbonato {
 public:
  AbbonatoTraffico(const std::string& name = "",const std::string& surname = ""): 
   Abbonato(name, surname), kb(6480) {
  }
  virtual double costoAttuale() const {
    return kb*0.001;
  }
 protected:
  long kb;
 private:
};

class FilialeSlowWeb {
 class Nodo {
  
 };
 public:
  FilialeSlowWeb(double sc = 0.0, int s = 0, int k = 0): 
   Sc(sc), S(s), K(k), listcount(0), list(NULL) {
  }
  ~FilialeSlowWeb() {
    if (list) {
      for (int i=0; i<listcount; i++) {
        AbbonatoTempo *at = dynamic_cast<AbbonatoTempo*>(list[i]);
        if (at) delete at;
        else delete dynamic_cast<AbbonatoTraffico*>(list[i]);
      }
      free(list);
    }
  }
  void inserisci(const Abbonato& a) {
    list = (Abbonato**)realloc(list, sizeof(Abbonato*)*(listcount+1));
    const AbbonatoTempo* at = dynamic_cast<const AbbonatoTempo*>(&a);
    if (at) {
      list[listcount++] = new AbbonatoTempo(*at);
    } else {
      list[listcount++] = new AbbonatoTraffico(dynamic_cast<const AbbonatoTraffico&>(a));
    }
  }
  double bolletta(const Abbonato& a) {
    //trova l'abbonato:
    AbbonatoTempo *at;
    AbbonatoTraffico *atr;
    int i;
    for (i=0; i<listcount; i++) {
      if (list[i]->get_nome() == a.get_nome() && 
          list[i]->get_cognome() == a.get_cognome()) {
        break;
      }
    }
    if (i >= listcount) return 0;
    at = dynamic_cast<AbbonatoTempo*>(list[i]);
    if (at) {
      return at->costoAttuale();
    } else {
      atr = dynamic_cast<AbbonatoTraffico*>(list[i]);
      return atr->costoAttuale();
    }
  }
  
  double totaleBollette() {
  }
 protected:
 private:
  double Sc;
  int S,K;
  int listcount;
  Abbonato **list;
};

int main() {
  AbbonatoTempo a1("Giacomo", "Pello");
  AbbonatoTempo a2("Anna", "Karenina");
  AbbonatoTraffico a3("Sandro", "Gorgo");
  AbbonatoTraffico a4("Giovanna", "Carnovale");
  
  FilialeSlowWeb fs(50.0, 10000, 50000); 
  fs.inserisci(a1);
  fs.inserisci(a2);
  fs.inserisci(a3);
  fs.inserisci(a4);
  
  std::cout << fs.bolletta(a1) << "\n"; 
  
  return 0;
}
