/* Polygon.h */

#ifndef POLYGON_H
#define POLYGON_H

#include "Polyhedron.h"

class Polygon: public Polyhedron{
 public:
 

  // ---- COSTRUTTORI ----
  
  // vuoto o con nome
  Polygon(const std::string& name = "Poligono");
  
  // lista di vertici
  Polygon(int numverts, const Point3Dd *listv, const std::string& name = "Poligono");
  
  // di copia
  Polygon(const Polygon& p);
  

  // ---- DISTRUTTORE ----

  virtual ~Polygon();


  // ---- OPERATORI ----
  
  // output su ostream
  friend std::ostream& operator << (std::ostream &os, const Polygon& ph);
  

  // ---- METODI ----
  
  // calcola l'area del poligono (risultato indefinito se non è convesso)
  virtual double get_area() const;
  
  // calcola il perimetro
  virtual double get_perimeter() const;
  
  // ritorna il volume ( = 0 essendo piatto)
  double get_volume() const { return 0; }
  
  // ritorna sempre vero
  bool is_flat() const { return true; }
  
  // ritorna vero se è convesso
  bool is_convex() const;
   
};

#endif
