/* QColorButton.h */

#ifndef QCOLORBUTTON_H
#define QCOLORBUTTON_H

#include <QPushButton>
#include <QColor>
#include <QIcon>

/* 
  Classe QColorButton
   Rapresenta un bottone per scegliere un colore
*/
class QColorButton: public QPushButton {
 Q_OBJECT
 
 public:

  // ---- COSTRUTTORI ----
  
  QColorButton(QColor color = Qt::black, QWidget* parent = 0);

  
  // ---- METODI PUBBLICI ----
  
  // ritorna il colore selezionato
  inline QColor getColor() const { return color; }
  
  // imposta il colore
  void setColor(QColor c);
 
 
 signals:
  // ---- SEGNALI ----

  // emesso quando il colore cambia
  void colorChanged(QColor );
 
 
 private slots:
  // ---- SLOT PRIVATI ----

  // apre la finestra per selezionare il colore
  void choosecolor();
  

 private:

  // il colore selezionato
  QColor color;
  
  // genera l'icona per il pulsante
  QIcon gen_icon() const;
 
};

#endif
