/* Dialog.cpp */

#include "Dialog.h"
#include "PolyAskDialog.h"

#include "Polyhedron.h"
#include "Prism.h"
#include "RectPrism.h"
#include "Pyramid.h"
#include "RectPyramid.h"
#include "Polygon.h"
#include "RegularPolygon.h"


// ---- COSTRUTTORI ----------------------------------------------------------

// standard
Dialog::Dialog() {
  
  resize(600,450);
  setWindowTitle("Database poliedrico :p");
  
  // actions
  createActions();
  
  // menu
  createMenu();
  
  // toolbar
  toolbar = addToolBar(tr("barra"));
  toolbar->addAction(act_insert);
  toolbar->addAction(act_delete);
  toolbar->addAction(act_cleardb);
  toolbar->addAction(act_showsearch);
  
  // statusbar
  statusbar = new QStatusBar(this);
  setStatusBar(statusbar);
  statusbar->showMessage(tr("ciao"), 3000);
  
  // search dock
  searchdock = new QDockWidget(tr("Ricerca"), this);
  searchdock->setMaximumWidth(300);
  searchdock->setHidden(true);
  addDockWidget(Qt::LeftDockWidgetArea, searchdock);
  
  // searchdock elements
  QFrame *frame_search = new QFrame();
  searchdock->setWidget(frame_search);
  QGridLayout *qsg = new QGridLayout(frame_search);
  
  searchcb_name = new QCheckBox(tr("Nome:"));
  searchcb_name->setCheckState(Qt::Checked);
  search_item_name = new QLineEdit();
  qsg->addWidget(searchcb_name, 0, 0);
  qsg->addWidget(search_item_name, 0, 1, 1,2);
  
  //connect(searchdock, SIGNAL(), search_item_name, SLOT(setFocus()));

  searchcb_color = new QCheckBox(tr("Colore:"));
  searchcb_color->setCheckState(Qt::Unchecked);
  search_color = new QColorButton();
  search_color->setDisabled(true);
  qsg->addWidget(searchcb_color, 1, 0);
  qsg->addWidget(search_color, 1, 1, 1,2);
  
  searchcb_surface = new QCheckBox(tr("Superficie:"));
  searchcb_surface->setCheckState(Qt::Unchecked);
  searchcombo_surface = new QComboBox();
  searchcombo_surface->addItem(tr("<"), 0);
  searchcombo_surface->addItem(tr("="), 1);
  searchcombo_surface->addItem(tr(">"), 2);
  searchcombo_surface->setDisabled(true);
  searchsb_surface = new QDoubleSpinBox();
  searchsb_surface->setDisabled(true);
  qsg->addWidget(searchcb_surface, 2, 0);
  qsg->addWidget(searchcombo_surface, 2, 1);
  qsg->addWidget(searchsb_surface, 2, 2);

  searchcb_volume = new QCheckBox(tr("Volume:"));
  searchcb_volume->setCheckState(Qt::Unchecked);
  searchcombo_volume = new QComboBox();
  searchcombo_volume->addItem(tr("<"), 0);
  searchcombo_volume->addItem(tr("="), 1);
  searchcombo_volume->addItem(tr(">"), 2);
  searchcombo_volume->setDisabled(true);
  searchsb_volume = new QDoubleSpinBox();
  searchsb_volume->setDisabled(true);
  qsg->addWidget(searchcb_volume, 3, 0);
  qsg->addWidget(searchcombo_volume, 3, 1);
  qsg->addWidget(searchsb_volume, 3, 2);  
  
  dosearch = new QPushButton(tr("Cerca"));
  qsg->addWidget(dosearch, 4,0,1,3);
  searchlist = new QTreeWidget();
  QStringList searchlabels; searchlabels << tr("Nome");
  searchlist->setHeaderLabels(searchlabels);
  searchlist->setColumnCount(1);
  searchlist->setAlternatingRowColors(true);
  searchlist->setSortingEnabled(false);
  searchlist->setRootIsDecorated(false);
  qsg->addWidget(searchlist, 5,0,1,3);
  
  
  // main frame
  QFrame *frame_main = new QFrame();
  setCentralWidget(frame_main);

  // main group boxes
  QVBoxLayout *qvb1 = new QVBoxLayout(frame_main);
  grp_db = new QGroupBox(tr("Database"));
  grp_item = new QGroupBox(tr("Elemento"));
  grp_item->setEnabled(false);
  qvb1->addWidget(grp_db);
  qvb1->addWidget(grp_item);
  
  // list
  QHBoxLayout *qhb1 = new QHBoxLayout(grp_db);
  list = new QTreeWidget();
  QStringList labels; labels << tr("Nome") << tr("Colore") << tr("Superficie") << tr("Volume");
  list->setHeaderLabels(labels);
  list->setColumnCount(4);
  list->setAlternatingRowColors(true);
  list->setSortingEnabled(true);
  list->setRootIsDecorated(false);
  qhb1->addWidget(list);

  // buttons for list
  QGroupBox *grp_dbbut = new QGroupBox("Azioni");
  QVBoxLayout *qvb2 = new QVBoxLayout(grp_dbbut);
  dbnew = new QPushButton(tr("Pulisci"));
  dbadd = new QPushButton(tr("Inserisci"));
  dbadd->setMenu(menu_additem);
  dbdel = new QPushButton(tr("Rimuovi"));
  dbdel->setEnabled(false);
  qvb2->addWidget(dbnew);
  qvb2->addWidget(dbadd);
  qvb2->addWidget(dbdel);
  qhb1->addWidget(grp_dbbut);
    
  // lower item fields
  QGridLayout *qg1 = new QGridLayout(grp_item);
  QLabel *qlname = new QLabel(tr("Nome:"));
  QLabel *qlcolor = new QLabel(tr("Colore:"));
  QLabel *qlsurface = new QLabel(tr("Superficie:"));
  QLabel *qlvolume = new QLabel(tr("Volume:"));
  qg1->addWidget(qlname, 0, 0);
  qg1->addWidget(qlcolor, 1, 0);
  qg1->addWidget(qlsurface, 2, 0);
  qg1->addWidget(qlvolume, 3, 0);
  item_name = new QLineEdit();
  itemcolor = new QColorButton();
  item_surface = new QLabel();
  item_volume = new QLabel();
  qg1->addWidget(item_name, 0, 1);
  qg1->addWidget(itemcolor, 1, 1);  
  qg1->addWidget(item_surface, 2, 1);
  qg1->addWidget(item_volume, 3, 1);        
  QGroupBox *grp_itembut = new QGroupBox(tr("Azioni"));
  qg1->addWidget(grp_itembut, 0,3, 3,1);
  preview = new QDrawSolid();
  preview->setScale(20.0);
  qg1->addWidget(preview, 0,2, 3,1);
  grp_item->setLayout(qg1);
  
  // item buttons
  QVBoxLayout *qvb3 = new QVBoxLayout(grp_itembut);
  itemsave = new QPushButton(tr("Salva"));
  itemcancel = new QPushButton(tr("Annulla"));
  qvb3->addWidget(itemsave);
  qvb3->addWidget(itemcancel);
  
  // connections
  createConnections();
  
  // poliedri
  createSolids();
}


// ---- SLOTS ----------------------------------------------------------------

// svuota il database
void Dialog::cleardb() {
  while (cont.length() > 0) delete cont.del_head();
  contChanged(CLEAR, NULL);
  
  // clear also search list
  searchlist->blockSignals(true);
  while (searchlist->topLevelItemCount() > 0) delete searchlist->takeTopLevelItem(0);
  searchlist->blockSignals(false);
}

// inserisce un poliedro
void Dialog::insert(polyType type) {
  Polycont::iterator *pi;
  int color;
  Point3Dd a(1,0,0),  b(0,1,0),   c(0,0,1), 
           d(1,1,0),  e(0,1,1),   f(1,0,1),
           g(-1,1,0), h(0,-1,1),  i(-1,0,1);  
  Point3Dd *ls1;
  Contenitore<std::string> labels, names;
  Contenitore<Point3Dd> plist1, plist2;
  Contenitore<Contenitore<Point3Dd> > plists;  
  Contenitore<int> intlist;
  
  srand(time(NULL)*(int)this);
  color = ((rand()&0xff)<<16) | ((rand()&0xff)<<8) | (rand()&0xff);
  labels.add_tail("Nome");

  switch (type) {
    case POLY: {
      labels.add_tail("Vertici");
      labels.add_tail("Colore");
      names.add_tail("Nuovo Poliedro");
      plist1.add_tail(a); plist1.add_tail(b);
      plist1.add_tail(c); plist1.add_tail(-d);
      plist1.add_tail(e); plist1.add_tail(-i);
      plists.add_tail(plist1);
      
      PolyAskDialog::parameters param("Parametri per Poliedro", &labels, &names, &plists, &intlist, &color);
      PolyAskDialog ad(&param, this);
      if (ad.exec() != QDialog::Accepted) return;
      ls1 = plists.get_head().to_array();
      Polyhedron *p = new Polyhedron(plists.get_head().length(), ls1, names.get_head());
      p->set_color(color);
      if (ls1) free(ls1);
      cont.add_head(p);
      break;
    }
    case PRISM: {
      labels.add_tail("Vertici della base");
      labels.add_tail("Direzione dello spigolo");
      labels.add_tail("Altezza");
      labels.add_tail("Colore");
      names.add_tail("Nuovo Prisma");
      plist1.add_tail(-d); plist1.add_tail(g);
      plist1.add_tail(P3Dd_ZERO); plist1.add_tail(d);
      plist1.add_tail(-g); plist1.add_tail(-2.0*b);
      plist2.add_tail(c+0.5*a);
      plists.add_tail(plist1);
      plists.add_tail(plist2);
      intlist.add_tail(3);
      
      PolyAskDialog::parameters param("Parametri per Prisma", &labels, &names, &plists, &intlist, &color);
      PolyAskDialog ad(&param);
      if (ad.exec() != QDialog::Accepted) return;
      ls1 = plists.get_head().to_array();
      Prism *p = new Prism(plists.get_head().length(), ls1, intlist.get_head(), plists.get_tail().get_head(), names.get_head());
      p->set_color(color);
      if (ls1) free(ls1);
      cont.add_head(p);
      break;
    }
    case RECTPRISM: {
      labels.add_tail("Vertici della base");
      labels.add_tail("Altezza");
      labels.add_tail("Colore");
      names.add_tail("Nuovo Prisma retto");
      plist1.add_tail(-2.0*a+b); plist1.add_tail(2.0*a+b);
      plist1.add_tail(-2.0*a-b); plist1.add_tail(2.0*a-b);
      plists.add_tail(plist1);
      intlist.add_tail(2);
      
      PolyAskDialog::parameters param("Parametri per Prisma retto", &labels, &names, &plists, &intlist, &color);
      PolyAskDialog ad(&param);
      if (ad.exec() != QDialog::Accepted) return;
      ls1 = plists.get_head().to_array();
      RectPrism *p = new RectPrism(plists.get_head().length(), ls1, intlist.get_head(), names.get_head());
      p->set_color(color);
      if (ls1) free(ls1);
      cont.add_head(p);
      break;
    }
    case PYRAMID: {
      labels.add_tail("Vertici della base");
      labels.add_tail("Vertice");
      labels.add_tail("Colore");
      names.add_tail("Nuova Piramide");
      plist1.add_tail(a); plist1.add_tail(b); plist1.add_tail(-d);
      plist2.add_tail(c+a+b);
      plists.add_tail(plist1);
      plists.add_tail(plist2);
      
      PolyAskDialog::parameters param("Parametri per Piramide", &labels, &names, &plists, &intlist, &color);
      PolyAskDialog ad(&param);
      if (ad.exec() != QDialog::Accepted) return;
      ls1 = plists.get_head().to_array();
      Pyramid *p = new Pyramid(plists.get_head().length(), ls1, plists.get_tail().get_head(), names.get_head());
      p->set_color(color);
      if (ls1) free(ls1);
      cont.add_head(p);
      break;
    }
    case RECTPYRAMID: {
      labels.add_tail("Vertici della base");
      labels.add_tail("Altezza");
      labels.add_tail("Colore");
      names.add_tail("Nuova Piramide retta");
      plist1.add_tail(a); plist1.add_tail(b); 
      plist1.add_tail(-a); plist1.add_tail(-b); 
      plists.add_tail(plist1);
      intlist.add_tail(2);      
      
      PolyAskDialog::parameters param("Parametri per Piramide retta", &labels, &names, &plists, &intlist, &color);
      PolyAskDialog ad(&param);
      if (ad.exec() != QDialog::Accepted) return;
      ls1 = plists.get_head().to_array();
      RectPyramid *p = new RectPyramid(plists.get_head().length(), ls1, intlist.get_head(), names.get_head());
      p->set_color(color);
      if (ls1) free(ls1);
      cont.add_head(p);
      break;
    }
    case POLYGON: {
      labels.add_tail("Vertici");
      labels.add_tail("Colore");
      names.add_tail("Nuovo Poligono");
      plist1.add_tail(a); plist1.add_tail(b);
      plist1.add_tail(2.0*b); plist1.add_tail(3.0*a);
      plists.add_tail(plist1);
      
      PolyAskDialog::parameters param("Parametri per Poligono", &labels, &names, &plists, &intlist, &color);
      PolyAskDialog ad(&param);
      if (ad.exec() != QDialog::Accepted) return;
      ls1 = plists.get_head().to_array();
      Polygon *p = new Polygon(plists.get_head().length(), ls1, names.get_head());
      p->set_color(color);
      if (ls1) free(ls1);
      cont.add_head(p);
      break;
    }
    case REGPOLYGON: {
      labels.add_tail("Vertici del lato");
      labels.add_tail("Vertice per il piano");
      labels.add_tail("Numero di lati");
      labels.add_tail("Colore");
      names.add_tail("Nuovo Poligono regolare");
      plist1.add_tail(P3Dd_ZERO); plist1.add_tail(a);
      plist2.add_tail(d);
      plists.add_tail(plist1);
      plists.add_tail(plist2);
      intlist.add_tail(5);
      
      PolyAskDialog::parameters param("Parametri per Poligono regolare", &labels, &names, &plists, &intlist, &color);
      PolyAskDialog ad(&param);
      if (ad.exec() != QDialog::Accepted) return;
      RegularPolygon *p = new RegularPolygon(intlist.get_head(), 
        plists.get_head().get_head(),
        plists.get_head().get_tail(),
        plists.get_tail().get_head(), names.get_head());
      p->set_color(color);
      cont.add_head(p);
      break;
    }
  }
  pi = new Polycont::iterator(cont.begin());
  contChanged(ADD, pi);
}

// cerca
void Dialog::search() {
  poly_find_data fdata;
  
  fdata.find_name = (searchcb_name->checkState() == Qt::Checked);
  fdata.find_color = (searchcb_color->checkState() == Qt::Checked);
  fdata.find_surface = (searchcb_surface->checkState() == Qt::Checked);
  fdata.find_volume = (searchcb_volume->checkState() == Qt::Checked);
  if (fdata.find_name) fdata.name = search_item_name->text().toStdString();
  if (fdata.find_color) fdata.color = search_color->getColor().rgb();
  if (fdata.find_surface) {
    fdata.cmp_surface = searchcombo_surface->currentIndex();
    fdata.surface = searchsb_surface->value();
  }
  if (fdata.find_volume) {
    fdata.cmp_volume = searchcombo_volume->currentIndex();
    fdata.volume = searchsb_volume->value();
  }
  Contenitore<Polycont::iterator> fcont = cont.find(poly_compare, static_cast<void*>(&fdata));
  Contenitore<Polycont::iterator>::iterator i = fcont.begin();
  
  searchlist->blockSignals(true);
  while (searchlist->topLevelItemCount() > 0) delete searchlist->takeTopLevelItem(0);
  searchlist->blockSignals(false);
  
  for (; !i.is_null(); ++i) {
    QStringList r;
    r << QString::fromStdString((**i)->get_name());
    QTreeWidgetItem *qr1 = new QTreeWidgetItem(r);
    qr1->setData(0, Qt::UserRole, reinterpret_cast<int>((**i)->get_extradata()));
    searchlist->addTopLevelItem(qr1);  
    searchlist->setCurrentItem(qr1);
  }
}

// seleziona nella lista principale quando si seleziona nella lista di ricerca
void Dialog::syncSearchList(QTreeWidgetItem *cur) {
  if (cur) {
    QTreeWidgetItem *tosel = reinterpret_cast<QTreeWidgetItem*>(cur->data(0, Qt::UserRole).toInt());
    if (list->indexOfTopLevelItem(tosel) >= 0) list->setCurrentItem(tosel);
  }
}

// cancella un elemento
void Dialog::deleteitem() {
  if (!list->currentItem()) return;
  Polycont::iterator *i = reinterpret_cast<Polycont::iterator *>
    (list->currentItem()->data(0, Qt::UserRole).toInt());
  delete **i;
  cont.del(*i);
  delete i;
  contChanged(DEL, NULL, list->currentItem());
}

// mostra un elemento
void Dialog::showitem(QTreeWidgetItem *cur) {
  if (cur) {
    grp_item->setEnabled(true);
    dbdel->setEnabled(true);
    item_name->setText(cur->text(0));
    Polycont::iterator *i = reinterpret_cast<Polycont::iterator *>
      (list->currentItem()->data(0, Qt::UserRole).toInt());
    double t = cont[*i]->get_area();
    item_surface->setText((t>=0)?(QString::number(t)):QString("?"));
    t = cont[*i]->get_volume();
    item_volume->setText((t>=0)?(QString::number(t)):QString("?"));
    itemcolor->setColor(QColor(cont[*i]->get_color()));
    preview->setPolyhedron(*(cont[*i]));
    preview->setColor(itemcolor->getColor());
  } else {
    grp_item->setEnabled(false);
    dbdel->setEnabled(false);
    item_name->setText("");
    item_surface->setText("");
    item_volume->setText("");
    preview->clear();
  }
}

// salva i dati di un elemento
void Dialog::saveitem() {
  if (!list->currentItem()) return;
  Polycont::iterator *i = reinterpret_cast<Polycont::iterator *>
    (list->currentItem()->data(0, Qt::UserRole).toInt());
  //todo: check non empty
  cont[*i]->set_name(item_name->text().toStdString());
  cont[*i]->set_color(QColor(itemcolor->text()).rgb());
  
  // update list
  list->currentItem()->setData(0,Qt::DisplayRole, item_name->text());
  list->currentItem()->setBackground(1,QColor(itemcolor->text()));
}

// aggiorna la lista dopo un cambiamento
void Dialog::updateList(chType what, Polycont::iterator *it, QTreeWidgetItem *wi) {
  switch (what) {
    case CLEAR: {
      //list->clear();
      list->blockSignals(true);
      while (list->topLevelItemCount() > 0) delete list->takeTopLevelItem(0);
      list->blockSignals(false);
      cancelitem();
      break;
    }
    case ADD: {
      QStringList r;
      r << tr(cont[*it]->get_name().c_str());
      QTreeWidgetItem *qr1 = new QTreeWidgetItem(r);
      qr1->setData(0, Qt::UserRole, reinterpret_cast<int>(it));
      qr1->setData(1, Qt::BackgroundRole, QBrush(QColor(cont[*it]->get_color())));
      double t = cont[*it]->get_area();
      qr1->setData(2, Qt::DisplayRole, (t>=0)?QString::number(t):"?");
      t = cont[*it]->get_volume();
      qr1->setData(3, Qt::DisplayRole, (t>=0)?QString::number(t):"?");
      list->addTopLevelItem(qr1);  
      list->setCurrentItem(qr1);
      (**it)->set_extradata(qr1);
      break;
    }
    case CHANGE: {
      break;
    }
    case DEL: {
      delete list->takeTopLevelItem(list->indexOfTopLevelItem(wi));    
      break;
    }
  }
}

// annulla i cambiamenti
void Dialog::cancelitem() {
  showitem(list->currentItem());
}

// finestra di informazioni
void Dialog::about() {
  QString text("Database Poliedrico\nDaniele Ferro\n\nQuesto inutile database \
consente di gestire una collezione di poliedri.");
  QMessageBox::information(this, tr("About"), text);
}


// ---- METODI PRIVATI -------------------------------------------------------

// crea le azioni
void Dialog::createActions() {
  act_cleardb = new QAction(tr("&Pulisci"), this);
  act_cleardb->setToolTip(tr("Elimina tutti gli elementi del database"));
  act_cleardb->setStatusTip(tr("Elimina tutti gli elementi del database"));
  
  act_showsearch = new QAction(tr("&Cerca"), this);
  act_showsearch->setToolTip(tr("Cerca un elemento nel database"));
  act_showsearch->setStatusTip(tr("Cerca un elemento nel database"));
  act_showsearch->setShortcut(QKeySequence::Find);

  act_search = new QAction(tr("&Cerca"), this);
  act_search->setToolTip(tr("Avvia la ricerca"));
  act_search->setStatusTip(tr("Avvia la ricerca"));
  
  act_exit = new QAction(tr("&Esci"), this);
  act_exit->setToolTip(tr("Esci dal programma"));
  act_exit->setStatusTip(tr("Esci dal programma"));
  act_exit->setShortcut(QKeySequence(Qt::CTRL + Qt::Key_Q));

  act_insert = new QAction(tr("&Inserisci"), this);
  act_insert->setToolTip(tr("Inserisce un elemento nel database"));
  act_insert->setStatusTip(tr("Inserisce un elemento nel database"));
  act_insert->setShortcut(QKeySequence(Qt::CTRL + Qt::Key_I));
  
  act_insertpoly = new QAction(tr("Poliedro"), this);
  act_insertpoly->setToolTip(tr("Inserisce un poliedro generico"));
  act_insertpoly->setStatusTip(tr("Inserisce un poliedro generico"));
  act_insertprism = new QAction(tr("Prisma"), this);
  act_insertprism->setToolTip(tr("Inserisce un prisma"));
  act_insertprism->setStatusTip(tr("Inserisce un prisma"));
  act_insertrectprism = new QAction(tr("Prisma retto"), this);
  act_insertrectprism->setToolTip(tr("Inserisce un prisma retto"));
  act_insertrectprism->setStatusTip(tr("Inserisce un prisma retto"));
  act_insertpyramid = new QAction(tr("Piramide"), this);
  act_insertpyramid->setToolTip(tr("Inserisce una piramide"));
  act_insertpyramid->setStatusTip(tr("Inserisce una piramide"));
  act_insertrectpyramid = new QAction(tr("Piramide retta"), this);
  act_insertrectpyramid->setToolTip(tr("Inserisce una piramide retta"));
  act_insertrectpyramid->setStatusTip(tr("Inserisce una piramide retta"));
  act_insertpolygon = new QAction(tr("Poligono"), this);
  act_insertpolygon->setToolTip(tr("Inserisce un poligono generico"));
  act_insertpolygon->setStatusTip(tr("Inserisce un poligono generico"));
  act_insertregularpolygon = new QAction(tr("Poligono regolare"), this);
  act_insertregularpolygon->setToolTip(tr("Inserisce un poligono regolare"));
  act_insertregularpolygon->setStatusTip(tr("Inserisce un poligono regolare"));

  act_delete = new QAction(tr("&Rimuovi"), this);
  act_delete->setToolTip(tr("Rimuove un elemento dal database"));
  act_delete->setStatusTip(tr("Rimuove un elemento dal database"));
  act_delete->setShortcut(QKeySequence(Qt::CTRL + Qt::Key_R));
  
  act_itemsave = new QAction(tr("&Salva elemento"), this);
  act_itemsave->setToolTip(tr("Salva i dati per questo elemento"));
  act_itemsave->setStatusTip(tr("Salva i dati per questo elemento"));

  act_about = new QAction(tr("&About"), this);
  act_about->setToolTip(tr("Informazioni sul programma"));
  act_about->setStatusTip(tr("Informazioni sul programma"));
}

// crea le connessioni
void Dialog::createConnections() {
  // clear
  connect(act_cleardb, SIGNAL(triggered()), this, SLOT(cleardb()));
  connect(dbnew, SIGNAL(clicked()), act_cleardb, SLOT(trigger()));
  
  // showsearch
  connect(act_showsearch, SIGNAL(triggered()), searchdock, SLOT(show()));
  connect(act_showsearch, SIGNAL(triggered()), search_item_name, SLOT(setFocus()));
  
  // search
  connect(act_search, SIGNAL(triggered()), this, SLOT(search()));
  connect(dosearch, SIGNAL(clicked()), act_search, SLOT(trigger()));
  
  // search checkboxes
  connect(searchcb_name, SIGNAL(toggled(bool)), search_item_name, SLOT(setEnabled(bool)));
  connect(searchcb_color, SIGNAL(toggled(bool)), search_color, SLOT(setEnabled(bool)));
  connect(searchcb_surface, SIGNAL(toggled(bool)), searchcombo_surface, SLOT(setEnabled(bool)));
  connect(searchcb_surface, SIGNAL(toggled(bool)), searchsb_surface, SLOT(setEnabled(bool)));
  connect(searchcb_volume, SIGNAL(toggled(bool)), searchcombo_volume, SLOT(setEnabled(bool)));
  connect(searchcb_volume, SIGNAL(toggled(bool)), searchsb_volume, SLOT(setEnabled(bool)));
  
  // search list
  connect(searchlist, SIGNAL(currentItemChanged(QTreeWidgetItem *,QTreeWidgetItem *)),
          this, SLOT(syncSearchList(QTreeWidgetItem *)));

  // exit
  connect(act_exit, SIGNAL(triggered()), this, SLOT(close()));
  
  // insert
  connect(act_insertpoly, SIGNAL(triggered()), this, SLOT(insert_poly()));
  connect(act_insertprism, SIGNAL(triggered()), this, SLOT(insert_prism()));
  connect(act_insertrectprism, SIGNAL(triggered()), this, SLOT(insert_rectprism()));
  connect(act_insertpyramid, SIGNAL(triggered()), this, SLOT(insert_pyramid()));
  connect(act_insertrectpyramid, SIGNAL(triggered()), this, SLOT(insert_rectpyramid()));
  connect(act_insertpolygon, SIGNAL(triggered()), this, SLOT(insert_polygon()));
  connect(act_insertregularpolygon, SIGNAL(triggered()), this, SLOT(insert_regularpolygon()));

  // delete
  connect(act_delete, SIGNAL(triggered()), this, SLOT(deleteitem()));
  connect(dbdel, SIGNAL(clicked()), act_delete, SLOT(trigger()));
  
  // color button
  connect(itemcolor, SIGNAL(colorChanged(QColor)), preview, SLOT(setColor(QColor)));
  
  // showitem
  connect(list, SIGNAL(currentItemChanged(QTreeWidgetItem *, QTreeWidgetItem *)),
          this, SLOT(showitem(QTreeWidgetItem *)));
  
  // saveitem
  connect(act_itemsave, SIGNAL(triggered()), this, SLOT(saveitem()));
  connect(itemsave, SIGNAL(clicked()), act_itemsave, SLOT(trigger()));
  
  // cancelitem
  connect(itemcancel, SIGNAL(clicked()), this, SLOT(cancelitem()));
  
  // updatelist
  connect(this, SIGNAL(contChanged(chType, Polycont::iterator*, QTreeWidgetItem*)),
          this, SLOT(updateList(chType, Polycont::iterator*, QTreeWidgetItem*)));

  // about
  connect(act_about, SIGNAL(triggered()), this, SLOT(about()));
}

// crea il menu
void Dialog::createMenu() {
  menubar = menuBar();

  menu_additem = new QMenu(tr("&Inserisci"), this);
  menu_additem->addAction(act_insertpoly);
  menu_additem->addAction(act_insertprism);
  menu_additem->addAction(act_insertrectprism);
  menu_additem->addAction(act_insertpyramid);
  menu_additem->addAction(act_insertrectpyramid);
  menu_additem->addAction(act_insertpolygon);
  menu_additem->addAction(act_insertregularpolygon);
  act_insert->setMenu(menu_additem);
  
  menu_file = new QMenu(tr("&File"), this);
  menu_file->addAction(act_insert);
  menu_file->addAction(act_delete);
  menu_file->addAction(act_cleardb);
  menu_file->addAction(act_showsearch);
  menu_file->addAction(act_exit);
  menubar->addMenu(menu_file);
    
  menu_help = new QMenu(tr("&Help"), this);
  menu_help->addAction(act_about);
  menubar->addMenu(menu_help);
}

// crea i poliedri iniziali per il database
void Dialog::createSolids() {
  Point3Dd p01(-1,0,0), p02(1,0,0), p03(0,-1,0), p04(0,1,0),
           p05(0,0,-1), p06(0,0,1), p07(-1,-1,0), p08(1,-1,0),
           p09(-1,1,0), p10(1,1,0), p11(0,-1,-1), p12(0,1,-1),
           p13(0,-1,1), p14(0,1,1), p15(-1,0,-1), p16(1,0,-1),
           p17(-1,0,1), p18(1,0,1), p19(0,0,4), p20(0,-3,0);
           
  srand(time(NULL));
  
  for (int i=0; i<4; i++) {
    int punti = rand()%10+4;
    Point3Dd list[13];
    char name[20];
    sprintf(name, "Poliedro %i", i+1);
    for (int j=0; j<punti; j++) list[j] = Point3Dd(rand()%10-5, rand()%10-5, rand()%10-5);
    Polyhedron *pol = new Polyhedron(punti, list, name);
    pol->set_color(((rand()&0xff)<<16)|((rand()&0xff)<<8)|(rand()&0xff));
    cont.add_head(pol);
    contChanged(ADD, new Polycont::iterator(cont.begin()));
  }

  Point3Dd ls01[] = {p01,p02,p03,p04,p09};
  Prism *pr = new Prism(5, ls01, 2, p06, "Casetta");
  pr->set_color(0x9040a0);
  cont.add_head(pr);
  contChanged(ADD, new Polycont::iterator(cont.begin()));
  
  Point3Dd ls02[] = {p07,p08,p09,p10};
  Pyramid *py = new Pyramid(4, ls02, p19/2, "Piramide");
  py->set_color(0x60b080);
  cont.add_head(py);
  contChanged(ADD, new Polycont::iterator(cont.begin()));

  Point3Dd ls03[] = {p01,p06,p14};
  Pyramid *py2 = new Pyramid(3, ls03, p05, "Triedro");
  py2->set_color(0xb07020);
  cont.add_head(py2);
  contChanged(ADD, new Polycont::iterator(cont.begin()));
  
  Point3Dd lsp1[] = {p02+3.0*p04, -p02+2.0*p04, -2.0*p02, -p02-2.0*p04, p02-3.0*p04, -p04,p04};
  Polygon *p1 = new Polygon(7, lsp1, "Luna");
  p1->set_color(0x1070d0);
  cont.add_head(p1);
  contChanged(ADD, new Polycont::iterator(cont.begin()));

  RegularPolygon *rp1 = new RegularPolygon(8, p01, p02, p06, "Ottagono");
  rp1->set_color(0x301080);
  cont.add_head(rp1);
  contChanged(ADD, new Polycont::iterator(cont.begin()));

  RegularPolygon *rp2 = new RegularPolygon(5, p02, p03, p10, "Pentagono");
  rp2->set_color(0xd0d010);
  cont.add_head(rp2);
  contChanged(ADD, new Polycont::iterator(cont.begin()));
  
}

// funzione per la ricerca
bool Dialog::poly_compare(Polyhedron* const* p, const void *comp) {
  const poly_find_data *data = static_cast<const poly_find_data*>(comp);
  const Polyhedron *po = *p;
  if (data->find_name) {
    if (po->get_name().find(data->name,0) == std::string::npos) return false;
  }
  if (data->find_color) {
    if (po->get_color() != data->color) return false;
  }
  if (data->find_surface) {
    switch (data->cmp_surface) {
      case 0: if (po->get_area() >= data->surface) return false; break;
      case 1: if (po->get_area() != data->surface) return false; break;
      case 2: if (po->get_area() <= data->surface) return false; break;
    }
  }
  if (data->find_volume) {
    switch (data->cmp_volume) {
      case 0: if (po->get_volume() >= data->volume) return false; break;
      case 1: if (po->get_volume() != data->volume) return false; break;
      case 2: if (po->get_volume() <= data->volume) return false; break;
    }
  }
  return true;
}
