/* PolyAskDialog.h */

#ifndef POLYASKDIALOG_H
#define POLYASKDIALOG_H

#include <string>
#include <QtGui>
#include "QColorButton.h"
#include "Point3D.h"
#include "Contenitore.h"

/*
  Classe PolyAskDialog:
   Rappresenta una finestra con la quale inserire i dati per la creazione
   di un nuovo poliedro
*/
class PolyAskDialog: public QDialog {
 Q_OBJECT
 
 public:
  
  // ---- SOTTO CLASSI ----
  
  // classe per passare i parametri alla finestra
  class parameters {
   public:
    friend class PolyAskDialog;
    parameters(std::string title,
               Contenitore<std::string>* labels,
               Contenitore<std::string>* names,
               Contenitore<Contenitore<Point3Dd> >* ptlists,
               Contenitore<int>* intlist,
               int *color );
   private:
    std::string title;
    Contenitore<std::string> *labels, *names;
    Contenitore<Contenitore<Point3Dd> >* ptlists;
    Contenitore<int>* intlist;
    int *color;
  };
  
  
  // ---- COSTRUTTORI ----
  
  // default
  PolyAskDialog(parameters *param, QWidget *parent = 0);
  
  
  // ---- DISTRUTTORE ----
  
  // ...nothing to say
  ~PolyAskDialog();
 

 public slots:  
  
  // ---- SLOT PUBBLICI ----
  
  // viene premuto "OK"
  virtual void accept();
  
  
 private:
  
  // ---- MEMBRI PRIVATI ----
  
  // i parametri per la creazione della finestra
  parameters *param;
  
  // i vari oggetti grafici
  QGridLayout *qg;
  QLabel **list_labels;
  QLineEdit **list_names, **list_ptedit;
  QSpinBox **list_int;
  QColorButton *btn_color;
  QDialogButtonBox *btn_box;


  // ---- METODI STATICI PRIVATI ----
  
  // converte un contenitore di punti in una QString
  static QString plist2qstring(const Contenitore<Point3Dd>& list);
  
  // converte una stringa in un contenitore di punti
  // ritorna falso se la stringa è malformata
  static bool qstring2plist(const QString& s, Contenitore<Point3Dd> *list);
  
};
#endif

