/* Prism.h */

#ifndef PRISM_H
#define PRISM_H

#include "Polyhedron.h"
#include "Polygon.h"

/* Un prisma (assumo che la base sia convessa) */
class Prism: public Polyhedron {
 public:

  // ---- COSTRUTTORI ----
  
  // con lista di vertici, altezza e direzione dell'altezza
  Prism(int vertbase, const Point3Dd *listvb, double h, Point3Dd hdir, std::string n = "Prisma");
  

  // ---- OPERATORI ----

  // output su ostream
  friend std::ostream& operator << (std::ostream &os, const Prism& pr);
  

  // ---- METODI PUBBLICI ----
  
  // ritorna l'altezza
  inline double get_height() const { return height; }
  
  // calcola l'area della base
  double get_basearea() const;
  
  // calcola l'area della base
  double get_baseperimeter() const;
  
  // calcola la superficie
  virtual double get_area() const;
  
  // calcola il volume
  virtual double get_volume() const;
  
  // ritorna il poligono di base
  Polygon get_base() const;
  
 protected:
 
  // altezza
  double height;
  
  // spigolo laterale
  double edge;
  
};

#endif
