/* Pyramid.h */

#ifndef PYRAMID_H
#define PYRAMID_H

#include "Polyhedron.h"
#include "Polygon.h"

/* Una piramide (a base convessa) */
class Pyramid: public Polyhedron {
 public:
  

  // ---- COSTRUTTORI --------------------------------------------------------
  
  // con lista di vertici della base e vertice
  Pyramid(int vertbase, const Point3Dd *listvb, Point3Dd v, std::string n = "Piramide");

  
  // ---- COSTRUTTORI --------------------------------------------------------
  
  // output su ostream
  friend std::ostream& operator << (std::ostream &os, const Pyramid& pr);


  // ---- METODI -------------------------------------------------------------
  
  // altezza della piramide
  inline double get_height() const { return height; }
  
  // area di base
  double get_basearea() const;
  
  // perimetro di base
  double get_baseperimeter() const;
  
  // area della superficie
  virtual double get_area() const;
  
  // volume
  virtual double get_volume() const;
  
  // poligono di base
  Polygon get_base() const;
  
 protected:
 
  // altezza
  double height;
  
  // metodo che calcola l'altezza
  double calc_height();
 
};

#endif
