/* RectPrism.cpp */

#include "RectPrism.h"


// ---- COSTRUTTORI ----------------------------------------------------------

// Crea un prisma retto i cui vertici di base sono listvb, di altezza h. 
// Non viene controllato se i punti della base stanno effettivamente su un piano.
RectPrism::RectPrism(int vertbase, const Point3Dd *listvb, double h, std::string n):
 Prism(vertbase, listvb, h, 
   h*((listvb[1]-listvb[0]).cross(listvb[2]-listvb[0])).normalize(), n) {
}


// ---- OPERATORI ------------------------------------------------------------

// output su ostream
std::ostream& operator << (std::ostream &os, const RectPrism& pr) {
  os << "RectPrism \"" << pr.name << "\":\n";
  for (int i=0; i<pr.vertices; i++)
    os << pr.verts[i] << ", ";
  return os << "\n";
}
