/* RegularPolygon.h */

#ifndef REGULARPOLYGON_H
#define REGULARPOLYGON_H

#include "Polygon.h"

/*
  Classe RegularPolygon:
   rappresenta un poligono regolare nello spazio
*/
class RegularPolygon: public Polygon {
 public:
 

  // ---- COSTRUTTORI ----

  // vuoto o con nome
  RegularPolygon(const std::string& name = "Poligono regolare");
  
  // 2 punti e punto nel piano
  RegularPolygon(int numverts, const Point3Dd& p1, const Point3Dd& p2, const Point3Dd& pplane, const std::string& name = "Poligono regolare");
  
  // di copia
  RegularPolygon(const RegularPolygon& p);
  

  // ---- DISTRUTTORE ----
  
  virtual ~RegularPolygon();

  
  // ---- OPERATORI ----
  
  
  // ---- METODI ----
  
  // area
  virtual double get_area() const;
  
  // perimetro
  virtual double get_perimeter() const;
  
  // lunghezza del lato
  virtual double get_edge_length() const;
  
  // raggio inscritto
  virtual double get_inscribed_radius() const;
  
  // raggio circoscritto
  virtual double get_circumscribed_radius() const;
  
  // vero se convesso
  bool is_convex() const { return true; }
   
};

#endif
