#include "telefonata.h"
#include "tempo.h"

Telefonata::Telefonata():
  start(0), end(0), num(0) {
}

Telefonata::Telefonata(const Tempo& st, const Tempo& en, int n):
  start(st), end(en), num(n) {
}

Tempo Telefonata::get_inizio() const {
  return start;
}

Tempo Telefonata::get_fine() const {
  return end;
}

int Telefonata::get_numero() const {
  return num;
}

Tempo Telefonata::get_durata() const {
  return end-start;
}

bool operator == (const Telefonata& t1, const Telefonata& t2) {
  return (t1.get_inizio() == t2.get_inizio()) &&
    (t1.get_fine() == t2.get_fine()) &&
    (t1.get_numero() == t2.get_numero());
}

ostream& operator<<(ostream& os, const Telefonata& t) {
  return os << "TELEFONATA: " << t.get_numero() << " (" << t.get_inizio() << " - " << t.get_fine() << ")";
}


