#include "tempo.h"

#include <iostream>

using std::ostream;

Tempo::Tempo() {
  sec = 0;
}

Tempo::Tempo(int h) {
  sec = (h < 0 || h > 23)?0:(3600*h);
}

Tempo::Tempo(int h, int m) {
  sec = (h < 0 || h > 23 || m < 0 || m > 59)?0:(3600*h+60*m);
}

Tempo::Tempo(int h, int m, int s) {
  sec = (h < 0 || h > 23 || m < 0 || m > 59 || s < 0 || s > 59)?0:(3600*h+60*m+s);
}

int Tempo::get_ore() const {
  return sec/3600;
}

int Tempo::get_minuti() const {
  return (sec/60)%60;
}

int Tempo::get_secondi() const {
  return sec % 60;
}

Tempo operator+(const Tempo& t1, const Tempo& t2) {
  Tempo t;
  t.sec = t1.sec+t2.sec;
  return t;
}

Tempo operator-(const Tempo& t1, const Tempo& t2) {
  Tempo t;
  if ((t.sec = t1.sec-t2.sec) < 0) return 0;
  return t;
}

bool operator==(const Tempo& t1, const Tempo& t2) {
  return (
    t1.get_ore() == t2.get_ore() && 
    t1.get_minuti() == t2.get_minuti() && 
    t1.get_secondi() == t2.get_secondi()
  );
}

bool operator<(const Tempo& t1, const Tempo& t2) {
  if (t1.get_ore() < t2.get_ore()) return true;
  else if (t1.get_ore() > t2.get_ore()) return false;
  if (t1.get_minuti() < t2.get_minuti()) return true;
  else if (t1.get_minuti() > t2.get_minuti()) return false;
  if (t1.get_secondi() < t2.get_secondi()) return true;
  return false;
}

bool operator<=(const Tempo& t1, const Tempo& t2) {
  if (t1.get_ore() < t2.get_ore()) return true;
  else if (t1.get_ore() > t2.get_ore()) return false;
  if (t1.get_minuti() < t2.get_minuti()) return true;
  else if (t1.get_minuti() > t2.get_minuti()) return false;
  if (t1.get_secondi() <= t2.get_secondi()) return true;
  return false;
}

bool operator>(const Tempo& t1, const Tempo& t2) {
  if (t1.get_ore() > t2.get_ore()) return true;
  else if (t1.get_ore() < t2.get_ore()) return false;
  if (t1.get_minuti() > t2.get_minuti()) return true;
  else if (t1.get_minuti() < t2.get_minuti()) return false;
  if (t1.get_secondi() > t2.get_secondi()) return true;
  return false;
}

bool operator>=(const Tempo& t1, const Tempo& t2) {
  if (t1.get_ore() > t2.get_ore()) return true;
  else if (t1.get_ore() < t2.get_ore()) return false;
  if (t1.get_minuti() > t2.get_minuti()) return true;
  else if (t1.get_minuti() < t2.get_minuti()) return false;
  if (t1.get_secondi() >= t2.get_secondi()) return true;
  return false;
}

ostream& operator<<(ostream& os, const Tempo& t) {
  return os << t.get_ore() << ":" << t.get_minuti() << ":" << t.get_secondi();
}
