/* CLASS SPACEDIR (header) */

#ifndef _CLASS_SPACEDIR_H
#define _CLASS_SPACEDIR_H

#include <SDL/SDL.h>

#include "../include/class_projector.h"
#include "../include/class_virscrsdl.h"

typedef struct {
  Point pos;
  unsigned int color;
  char *name;
  int filetype;
  char selected;
  SDL_Surface *text;
} Globe;

typedef struct {
  int x,y;
  PROJECTOR_TYPE z;
  int radius;
  int iglobe;
} Globe2D;

int cmpGlobe2D(const void *g1, const void *g2);

class Spacedir {
 public:

  Spacedir(SDL_Surface *Screen, const char *dir);
  ~Spacedir();
  
  int mainLoop(char **newdir);
  
 private:
  int iGlobes, iGlobes2;
  char navMode;
  PROJECTOR_TYPE navSpeed;
  char *dir;
  Globe *globes;
  Globe2D *globes2;
  SDL_Surface *screen;
  Projector *pro;
  VirtualScreenSDL *virscr;
  
  int draw();
  int drawOnly();
  int EditMenu(int x, int y);
  int OSD_Print(char *text);
  int CatchEvent(char **newdir);
  char *getUpDir();
  char *getNextDir(char *newdir);
  int getClicked(int x, int y);
};

#endif
