#include <stdio.h>
#include <stdlib.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

#include "class_spacedir.h"

#define min(a,b)	(((a)<(b))?(a):(b))

const int resx = 640;
const int resy = 480;
char *mydir = "/";

SDL_Surface *screen;


#include "cursor5.xpm"
#define cursordata cursor5_xpm
static SDL_Cursor *SDL_CreateXPMCursor() {
  int pos, i,j, w,h, cols;
  char c, cblack,cwhite,cnone, hex[20];
  Uint8 *data, *mask;
  sscanf(cursordata[0], "%i %i %i", &w, &h, &cols);
  
  data = (Uint8*)malloc((sizeof(Uint8)*w*h)/8);
  mask = (Uint8*)malloc((sizeof(Uint8)*w*h)/8);
  cblack = cwhite = cnone = 0;
  for (i=0; i<cols; i++) {
    sscanf(cursordata[1+i], "%c c %s", &c, hex);
    switch (hex[1]) { // very bad check!!
      case 'O':
      case 'o': cnone = c; break;
      case '0': cblack = c; break;
      case 'F':
      case 'f': cwhite = c; break;
    }
  }
  
  pos = -1;
  for (j=0; j<h; j++) {
    for (i=0; i<w; i++) {
      if ( i & 0x07 ) {
        data[pos] <<= 1;
        mask[pos] <<= 1;
      } else {
        ++pos;
        data[pos] = mask[pos] = 0;
      }
      c = cursordata[cols+1+j][i];
      if ( c == cblack) {
        data[pos] |= 0x01;
        mask[pos] |= 0x01;
      } else if ( c == cwhite) {
        mask[pos] |= 0x01;
      }
    }
  }

  sscanf(cursordata[1+cols+h], "%i,%i", &i,&j);
  SDL_Cursor *ret = SDL_CreateCursor(data, mask, w,h, i,j);
  free(data);
  free(mask);
  return(ret);
}


int errproc(int n) {
  printf("An error occurred: %s\n", SDL_GetError());
  exit(n);
}

int main() { // TODO: read command line
  int ret;
  char *newdir;
  ret = SDL_Init(SDL_INIT_VIDEO);
  if (ret != 0) errproc(-1);
  atexit(SDL_Quit);

  ret = TTF_Init();
  if (ret != 0) errproc(-1);
  atexit(TTF_Quit);
  
  /*char viddriv[30];
  SDL_VideoDriverName(viddriv, 30);
  printf("Driver video: %s\n", viddriv);
  
  const SDL_VideoInfo *vi = SDL_GetVideoInfo();
  printf("Hardware surfaces: %s\n", vi->hw_available?"yes":"no");
  printf("Window manager: %s\n", vi->wm_available?"yes":"no");
  printf("Video memory: %i Kb\n", vi->video_mem);
  
  SDL_Rect **modes = SDL_ListModes(NULL, SDL_HWSURFACE);
  if (modes == NULL) printf("No modes available\n");
  else if ((int)modes == -1) printf("Any mode is ok.\n");
  else {
    for(int i=0; modes[i]; i++) {
      printf("Mode %i: %ix%i\n", i, modes[i]->w, modes[i]->h);
    }
  }*/

  screen = SDL_SetVideoMode(resx,resy,32, SDL_HWSURFACE);
  if (screen == NULL) errproc(-2);
  
  SDL_WM_SetCaption("Space", "Space");
  
  
  SDL_Cursor *curs = SDL_CreateXPMCursor();
  if (curs != NULL) SDL_SetCursor(curs);

  Spacedir *sd;
  newdir = strdup(mydir);
  do {
    sd = new Spacedir(screen, newdir);
    free(newdir);
    ret = sd->mainLoop(&newdir);
    delete sd;  
    
  } while (ret != 0);
  
  if (curs != NULL) SDL_FreeCursor(curs);
  
  return(0);
}
