/*
ID: ziodf121
LANG: C++
TASK: dualpal
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int N, S;

// reverse a string
char *strrev(char *str) {
  int t, i, l = strlen(str);
  for (i=0; i<(l>>1); ++i) {
    t = str[i];
    str[i] = str[l-i-1];
    str[l-i-1] = t;
  }
  return str;
}

// can be faster
bool is_pali(const char *s) {
  char *rs = strdup(s);
  bool ret = !(strcmp(s, strrev(rs)));
  free(rs);
  return ret;
}

// in reverse order
char *to_base(int n, int base, char *out, int maxsize) {
  int r, pos=0;
  memset(out, 0, maxsize);
  if (n == 0) out[0] = '0';
  while (n) {
    r = n%base;
    n /= base;
    out[pos++] = '0'+r;
  }
  return out;
}

int main() {
  FILE *f = fopen("dualpal.in", "r");
  fscanf(f, "%i %i", &N, &S);
  fclose(f);

  f = fopen("dualpal.out", "w");
  char buf[50];
  int lcount, counter = 0;
  for (int i=S+1; counter<N; ++i) {
    lcount = 0;
    for (int base=2; base<=10; ++base) {
      if (is_pali(to_base(i, base, buf, 40))) lcount++;
      if (lcount >=2 ) {
        counter++;
        fprintf(f, "%i\n", i);
        //printf("%i\n", i);
        break;
      }
    }
    if (counter >= N) break;
  }
  fclose(f);
  
  return 0;
}