/*
ID: ziodf121
LANG: C++
TASK: hamming
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MAXN  64
#define MAXD  7

int N, B, D;

int count_cache[256];

int bitcount(int x) {
  int bits = 0;
  if (x < 256 && count_cache[x] != -1) return count_cache[x];
  while (x != 0) {
    bits += x & 0x1;
    x >>= 1;
  }
  if (x < 256) count_cache[x] = bits;
  return bits;
}

int hamming_dist(int a, int b) {
  return bitcount(a ^ b);
}

int nsol = 0;
int sol[MAXN];

int main() {

  FILE *f = fopen("hamming.in", "r");
  fscanf(f, "%i %i %i", &N, &B, &D);
  fclose(f);
  
  memset(count_cache, 0xff, sizeof(count_cache));
  
  int i,j;
  int maxnum = (1<<B);
  for (j=0; j<maxnum; ++j) {
    // assumo j sia ok
    sol[nsol++] = j;
    if (nsol >= N) break;
    for (i=j+1; i<maxnum; ++i) {
      // controllo se i va bene
      int isok = 1;
      for (int k=0; k<nsol; ++k) {
        if (hamming_dist(sol[k], i) < D) {
          isok = 0;
          break;
        }
      }
      if (isok) {  // aggiungo alle sol
        sol[nsol++] = i;
        if (nsol >= N) break;
      }
    }
    if (nsol >= N) break;
    // tolgo tutto
    nsol = 0;
  }
  
  f = fopen("hamming.out", "w");
  for (j=0; j<nsol; ++j) {
    fprintf(f, "%i", sol[j]);
    if ((j+1)%10 == 0) fprintf(f, "\n");
    else if (j<nsol-1) fprintf(f, " ");
  }
  if ((nsol%10)!= 0) fprintf(f, "\n");
  fclose(f);
  
  return 0;
}