/*
ID: ziodf121
LANG: C++
TASK: holstein
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MAXV	25
#define MAXG	15

int V,G;

int vs[MAXV];
int gs[MAXG][MAXV];

char comb[MAXG];

void print_comb() {
  for (int i=0; i<G; ++i) printf("%i ", comb[i]);
  printf("\n");
}

int is_comb_ok() {
 for (int vit=0; vit<V; ++vit) {
   int combsum = 0;
   for (int j=0; j<G; ++j) if (comb[j]) combsum += gs[j][vit];
   if (combsum < vs[vit]) return 0;
  }
  return 1;
}

void gen_comb(int ones, int start, int end) {
  if (ones == 0) {
    //print_comb();
    // check if ok
    if (is_comb_ok()) {
      // output
      //print_comb();
      int nscop = 0;
      for (int i=0; i<G; ++i) if (comb[i]) ++nscop;
      FILE *f = fopen("holstein.out", "w");
      fprintf(f, "%i", nscop);
      for (int i=0; i<G; ++i) if (comb[i]) fprintf(f, " %i", i+1);
      fprintf(f, "\n");
      fclose(f);
      // exit
      exit(0);
    }
    return;
  }
  
  for (int i=start; i<=end; ++i) {
    comb[i] = 1;
    gen_comb(ones-1, i+1, end);
    comb[i] = 0;
  }
}

void gen_all_comb() {
  for (int i=1; i<=G; ++i) {
    //memset(comb, 0, sizeof(comb));
    gen_comb(i, 0, G-1);
  }
}

int main() {

  FILE *f = fopen("holstein.in", "r");
  fscanf(f, "%u\n", &V);
  for (int i=0; i<V; ++i) fscanf(f, "%u ", vs+i);
  fscanf(f, "%u\n", &G);
  for (int j=0; j<G; ++j)
    for (int i=0; i<V; ++i) fscanf(f, "%u ", &(gs[j][i]));
  fclose(f);
  
  // clear comb
  memset(comb, 0, sizeof(comb));
  
  gen_all_comb();
  
  return 0;
}