/*
ID: ziodf121
LANG: C++
TASK: transform
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int N = 0;
char *grid1 = NULL, *grid2 = NULL;

void print_grid(const char *grid) {
  for (int j=0; j<N; ++j) {
    for (int i=0; i<N; ++i) {
      printf("%c", *(grid+j*N+i));
    }
    printf("\n");
  }
}

bool grid_match(const char *gr1, const char *gr2) {
  return !bcmp(gr1, gr2, sizeof(char)*N*N);
}

void rot_grid(const char *grin, char *grout, const int type) {
  int i,j;
  if (type == 0) { // 90
    for (j=0; j<N; ++j) {
      for (i=0; i<N; ++i) {
        *(grout+i*N+(N-1-j)) = *(grin+j*N+i);
      }
    }
  } else if (type == 1) { // 180
    for (j=0; j<N; ++j) {
      for (i=0; i<N; ++i) {
        *(grout+(N-1-j)*N+(N-1-i)) = *(grin+j*N+i);
      }
    }

  } else { // 270
    for (j=0; j<N; ++j) {
      for (i=0; i<N; ++i) {
        *(grout+(N-1-i)*N+j) = *(grin+j*N+i);
      }
    }
  }
}

void sym_grid(const char *grin, char *grout) {
  int i,j;
  for (j=0; j<N; ++j) {
    for (i=0; i<N; ++i) {
      *(grout+j*N+(N-1-i)) = *(grin+j*N+i);
    }
  }
}

int main() {
  int i,j;
  
  FILE *f = fopen("transform.in", "r");
  fscanf(f, "%i\n", &N);
  grid1 = (char*)malloc(sizeof(char)*N*N);
  grid2 = (char*)malloc(sizeof(char)*N*N);
  for (i=0; i<2*N; ++i) {
    char buf[20];
    fscanf(f, "%s\n", buf);
    memcpy(((i<N)?grid1:grid2)+N*(i%N), buf, sizeof(char)*N);
  }
  fclose(f);
  
  char *tgrid = (char*)malloc(sizeof(char)*N*N);
  char *tgrid2 = (char*)malloc(sizeof(char)*N*N);
  int ret = 0;
  
  rot_grid(grid1, tgrid, 0);
  if (grid_match(grid2, tgrid)) { ret = 1; goto end; }
  rot_grid(grid1, tgrid, 1);
  if (grid_match(grid2, tgrid)) { ret = 2; goto end; }
  rot_grid(grid1, tgrid, 2);
  if (grid_match(grid2, tgrid)) { ret = 3; goto end; }
  sym_grid(grid1, tgrid);
  if (grid_match(grid2, tgrid)) { ret = 4; goto end; }
  rot_grid(tgrid, tgrid2, 0);
  if (grid_match(grid2, tgrid2)) { ret = 5; goto end; }
  rot_grid(tgrid, tgrid2, 1);
  if (grid_match(grid2, tgrid2)) { ret = 5; goto end; }
  rot_grid(tgrid, tgrid2, 2);
  if (grid_match(grid2, tgrid2)) { ret = 5; goto end; }
  if (grid_match(grid1, grid2)) { ret = 6; goto end; }
  ret = 7;
  

  
  end:
  f = fopen("transform.out", "w");
  fprintf(f, "%i\n", ret);
  fclose(f);
  
  if (tgrid) free(tgrid);
  if (tgrid2) free(tgrid2);
  if (grid1) free(grid1);
  if (grid2) free(grid2);
  return 0;
}